// Arrange.cpp : Defines the entry point for the DLL application.
//

#include "stdafx.h"
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <math.h> 

#include "os.h"
#include "bbc.h"
#include "sprite.h"
#include "wimp.h"

#include "transform.h"

#include "xprocess.h"



#include "wos.h"
#include "poll.h"
#include "etc.h"
#include "fsx.h"
#include "bf.h"
#include "flex.h"
#include "sp.h"
#include "task.h"
#include "xhelp.h"
#include "trans.h"
#include "dbhi.h"
#include "key.h"
#include "temp.h"

#include "xext.h"



#include "constants.h"
#include "str.h"


#include "file.h"
#include "view.h"
#include "viewo.h"


#include "units.h"

#include "object.h"
#include "select.h"

#include "dbscale.h"







#include "arrange.h"



static HANDLE modulehandle;




extern dboxstr arrangeboxdata;


static int vertical;
static int mode;
static int spacing;
static int align=1;

static viewstr * cview;
static filestr * cfile;


#define TARRANGE 0x200


static os_error * objectdim(int object,int * d1,int * d2,
                                   int mode,int vertical,filestr * file)

{
 sobjectstr * sob;


 sob=(sobjectstr*)fob_find(object,file);

 switch(mode)
 {
   case   ALEFT:
                *d1=*d2=vertical?sob->box.y:sob->box.x;
                break;

   case  ARIGHT:
                *d1=*d2=vertical?(sob->box.y+sob->box.h):
                                 (sob->box.x+sob->box.w);
                break;

   case ACENTRE:
                *d1=*d2=vertical?(sob->box.y+sob->box.h/2):
                                 (sob->box.x+sob->box.w/2);
                break;

   case  AWIDTH:
                *d1=vertical?sob->box.y:sob->box.x;
                *d2=vertical?(*d1+sob->box.h):(*d1+sob->box.w);
                break;
 }

 return(NULL);
}




static int acmp(const void * p1,const void * p2)
{
 int          object1;
 int          object2;
 int          d11;
 int          d12;
 int          d21;
 int          d22;

 object1=*((int*)p1);
 object2=*((int*)p2);

 objectdim(object1,&d11,&d12,mode,vertical,cfile);
 objectdim(object2,&d21,&d22,mode,vertical,cfile);

 return(d11-d21);
}



static int adx;
static int ady;


static int atrf(transformstr * r,transformstr * t,
                                    curvestr * c,transformstr * ct)
{
 transformstr t1;
 tr_setshift(&t1,adx,ady);
 tr_multiply(r,t,&t1);
 return(TR_SHIFT);
 USE(ct);
 USE(c);
}



static int  * aslist;
static int    aselectn;
static int    target;
static int    tspacing;


static os_error * modfn(int object,filestr * file)
{
 int  i;
 int  j;
 int  d1;
 int  d2;
 int  shift;
 int  posn;

 shift=0;

 for(i=0;i<aselectn;i++)
   if(aslist[i]==object) break;

 objectdim(object,&d1,&d2,mode,vertical,file);

 if(mode==ALEFT || mode==ACENTRE)
 {
  shift=(target+i*tspacing)-d1;
 }
 else
 if(mode==ARIGHT)
 {
  shift=(target-(aselectn-1-i)*tspacing)-d1;
 }
 else
 if(mode==AWIDTH)
 {
  posn=target;
  shift=d1;

  for(j=0;j<i;j++)
  {
   objectdim(aslist[j],&d1,&d2,mode,vertical,file);
   posn+=tspacing+(d2-d1);
  }

  shift=posn-shift;
 }

 adx=ady=0;
 if(vertical) ady=shift;
 else         adx=shift;

 return(NULL);
}



static os_error * arrangeselection(int vertical,int mode,int spacing)
{
 os_error * err;
 int        d1;
 int        d2;
 int        i;
 int        min;
 int        max;



 err=makeaselectionlist(&aslist,&aselectn,NULL,NULL);
 if(!err)
 {
  qsort(aslist,aselectn,sizeof(int),acmp);

  if(mode==ALEFT || mode==AWIDTH)
  {
   objectdim(aslist[0],&d1,&d2,mode,vertical,cfile);
   target=d1;
  }
  else
  if(mode==ARIGHT)
  {
   objectdim(aslist[aselectn-1],&d1,&d2,mode,vertical,cfile);
   target=d1;
  }
  else
  if(mode==ACENTRE)
  {
   min=max=0;


   for(i=0;i<aselectn;i++)
   {
    objectdim(aslist[i],&d1,&d2,AWIDTH,vertical,cfile);

    if(i==0) 
    {
     min=d1;
     max=d2;
    }
    else     
    {
     min=MIN(min,d1);
     max=MAX(max,d2);
    }
   }

   target=(min+max)/2;
   if(!(aselectn & 0x1)) target-=spacing/2;
   target-=(aselectn/2-1)*spacing;
  }

  tspacing=spacing;

  err=transformselections(atrf,0,modfn);

  clearaselectionlist(&aslist);
 }

 return(err);
}




static int oldwidth;
static int oldheight;
static int newwidth;
static int newheight;
static int dmode;
static int dvertical;


static int dtrf(transformstr * r,transformstr * t,curvestr * c,transformstr * ct)
{
 transformstr temp1;
 transformstr temp2;
 transformstr temp3;
 transformstr rtransform;

 if(dvertical) tr_setscale(&rtransform,1,1,oldheight,newheight);
 else          tr_setscale(&rtransform,oldwidth,newwidth,1,1);

 tr_setshift(&temp1,-c->box.x,-c->box.y);
 tr_multiply(&temp2,&temp1,&rtransform);
 tr_setshift(&temp1,c->box.x,c->box.y);
 tr_multiply(&temp3,&temp2,&temp1);

 tr_multiply(r,&temp3,t);

 return(dvertical?TR_YSCALE:TR_XSCALE);
 USE(ct);
}




static os_error * dmodfn(int object,filestr * file)
{
 int d1;
 int d2;

 objectdim(object,&d1,&d2,dmode,dvertical,file);

 if(dvertical)
 {
  oldheight=d2-d1;
 }
 else
 {
  oldwidth=d2-d1;
 }


 return(NULL);
}






static os_error * dimensionselection(int samewidth)
{
 os_error * err;
 int        d1;
 int        d2;
 int        ob;

 if(nselected(&ob,cfile)>1)
 {
  dmode=AWIDTH;

  if(samewidth)
  {
   dvertical=0;
  }
  else
  {
   dvertical=1;
  }

  objectdim(ob,&d1,&d2,dmode,dvertical,cfile);

  newheight=newwidth=(d2-d1);

  err=transformselections(dtrf,0,dmodfn);
 }

 return(err);
}











static int getspacing(int mode,int vertical)
{
 selectedobjectstr * selection;
 int                 selectn;
 int                 i;
 int                 max;
 int                 min;
 int                 d1;
 int                 d2;
 int                 widths;


 d1=d2=min=max=0;    /* compiler */
 widths=0;

 getselection(NULL,NULL,&selection,&selectn);

 for(i=0;i<selectn;i++)
 {
  objectdim(selection[i].object,&d1,&d2,mode,vertical,cfile);

  if(i==0) 
  {
   min=d1;
   max=d2;
  }
  else     
  {
   min=MIN(min,d1);
   max=MAX(max,d2);
  }

  if(mode==AWIDTH) widths+=(d2-d1);
 }

 return((max-min-widths)/(selectn-1));
}



static os_error * arrangeclose(int code)
{
 os_error    * err;

 err=NULL;

 if(code==DBOK || code==DBAPPLY)
 {
  err=arrangeselection(vertical,mode,spacing);
 }

 return(err);
}



static os_error * out(int value,char * string)
{
 strcpy(string,unitstostring(value,cview->data.units));
 return(NULL);
}


static os_error * in(int * value,char * string)
{
 return(stringtounits(string,value,cview->data.units));
}




static os_error * optfn3(int handle,int userhandle,wimp_mousestr * m)
{
 if(align) spacing=0;
 else      spacing=getspacing(mode,vertical);

 dbchangevalue(&spacing,&arrangeboxdata);
 return(NULL);
 USE(userhandle);
 USE(handle);
 USE(m);
}


static os_error * optfn(int handle,int userhandle,wimp_mousestr * m)
{
 optfn3(handle,userhandle,m);

 dbshade(1,align?(DBSHADEG|DBWRITEG):0,&arrangeboxdata);

 return(NULL);
 USE(userhandle);
 USE(handle);
 USE(m);
}




static os_error * optfn2(int handle,int userhandle,wimp_mousestr * m)
{
 optfn3(handle,userhandle,m);

 if(vertical)
 {
  writeiconfc(handle,7,"{ARRTOP}");
  writeiconfc(handle,10,"{ARRBOT}");
  writeiconfc(handle,9,"{ARRHT}");
 }
 else
 {
  writeiconfc(handle,7,"{ARRLFT}");
  writeiconfc(handle,10,"{ARRRGT}");
  writeiconfc(handle,9,"{ARRWD}");
 }

 return(NULL);
 USE(userhandle);
 USE(m);
}



static os_error * optfn4(int handle,int userhandle,wimp_mousestr * m)
{
 if(m->i==13) return(dimensionselection(1));
 else         return(dimensionselection(0));
}



static dbiconstr arrangeicondefs[]=
{
 /* N   &V           Type     Grp   Flags   Msk Key   ESG   -   clickfn 0 */


    0,  &vertical,    DBRADIO, 0,    0,  0,     F2,  1,0,(dbreadfn)optfn2,0,
    6,  &vertical,    DBRADIO, 0,    0,  1,     F3,  1,0,(dbreadfn)optfn2,0,


    7,  &mode,        DBRADIO, 0,    0,  ALEFT,  F4, 2,0,(dbreadfn)optfn3,0,
   10,  &mode,        DBRADIO, 0,    0,  ARIGHT, F5, 2,0,(dbreadfn)optfn3,0,
    3,  &mode,        DBRADIO, 0,    0,  ACENTRE,F6, 2,0,(dbreadfn)optfn3,0,
    9,  &mode,        DBRADIO, 0,    0,  AWIDTH, F7, 2,0,(dbreadfn)optfn3,0,


 /* N   &V           Type     Grp   Flags   R   L   D   U     In    Out */

    4,  &spacing,     DBWRITE,  1,   0,   -1, -1, -1, -1,  in,  out,

    8,  &align,       DBRADIO, 0,   0,    1, F8, 3, 0, (dbreadfn)optfn,0,
   12,  &align,       DBRADIO, 0,   0,    0, F9, 3, 0, (dbreadfn)optfn,0,

 /* N   &V           Type     Grp   Flags   Act Key     - -   clickfn 0 */

    1, NULL,          DBACTION, 0,   0,      DBOK,RETURN, 0,0,    NULL, 0,
    2, NULL,          DBACTION, 0,   0,      DBCANCEL,ESCAPE, 0,0,NULL, 0,

   13, NULL,          DBACTION, 0,   0,      0,  0,  0,  0,(dbreadfn)optfn4,0,
   14, NULL,          DBACTION, 0,   0,      0,  0,  0,  0,(dbreadfn)optfn4,0,

 /* N   &V           Type     Grp   Flags   Msk Key -  -      clickfn 0 */

   -1, NULL,         0,       0,    0,      0,  0,  0,  0,  0,      0
};



static dboxstr arrangeboxdata=
{
 0,
 TARRANGE,
 DBFIX,
 0,
 arrangeclose,
 NULL,
 NULL,
 NULL,
 arrangeicondefs,
 0,
 0,
 0,NULL,
 0,
 0,
};



/* script function opens the new document dialogue box */

static int openarrangebox(int fp)
{
 os_error   * err;
 int          ob;

 cview=getmenuview();
 cfile=cview->file;

 if(nselected(&ob,cfile)>1)
 {
  if(align) spacing=0;
  else      spacing=getspacing(mode,vertical);

  err=dodboxspparent(&arrangeboxdata,1,&arrangeboxdata,getviewstack(),cview->handle);
  if(!err)
  {
   optfn2(arrangeboxdata.handle,0,NULL);
   optfn(arrangeboxdata.handle,0,NULL);
  }
 }

 return(0);

 USE(fp);
}






static char * arrangepath;



#define XFNS 2         


static fndefn fntable[XFNS]=
{
 "openarrangebox",(extfn)openarrangebox,"",PVOID,0,

 NULL,NULL,NULL,0,0
};


static xfnlink fnlink;


static os_error * scriptevent(int eventn,int userhandle,
                                                    void * data,int data1)
{
 remevent(EVENT_SCRIPTINIT,scriptevent,0);
 return(addsymboltable(fntable,&fnlink));

 USE(eventn);
 USE(userhandle);
 USE(data);
 USE(data1);
}





static templates temptable[]=
{
 TARRANGE,1,0,"Arrange",
 TLAST,0,0,""
};


static templink templatelink;




static os_error * templatesevent(int eventn,int userhandle,
                                                    void * data,int data1)
{
 remevent(EVENT_LOADTEMPLATES,templatesevent,0);

 return(addtemplates2(NULL,NULL,temptable,&templatelink,(ascaninstance)modulehandle));

 USE(eventn);
 USE(userhandle);
 USE(data);
 USE(data1);
}




static os_error * messevent(int eventn,int userhandle,void * data,int data1)
{
 remevent(EVENT_LOADMESSAGES,messevent,0);
 return(addtranstable(arrangepath,"Arrange\\Resources\\Messages.txt"));

 USE(eventn);
 USE(userhandle);
 USE(data);
 USE(data1);
}



static os_error * helpevent(int eventn,int userhandle,void * data,int data1)
{
 remevent(EVENT_LOADHELP,helpevent,0);
 return(addhelp(arrangepath,"Arrange\\Resources\\Help.txt"));

 USE(eventn);
 USE(userhandle);
 USE(data);
 USE(data1);
}




extern "C" __declspec(dllexport) os_error * entrypoint(char * path)
{ 
 os_error * err;

 arrangepath=path;

          err=addevent(EVENT_LOADTEMPLATES,templatesevent,0);
 if(!err) err=addevent(EVENT_SCRIPTINIT,scriptevent,0);
 if(!err) err=addevent(EVENT_LOADMESSAGES,messevent,0);
 if(!err) err=addevent(EVENT_LOADHELP,helpevent,0);

 return(err);
}








extern "C" BOOL __stdcall _DllMainCRTStartup( 
    HINSTANCE hinstDLL,     // handle to DLL module 
    DWORD fdwReason,        // reason for calling function 
    LPVOID lpvReserved)     // reserved 
{
 
 modulehandle=(HMODULE)hinstDLL;
 return(TRUE);
}

