/*->c.icc */



#include "stdafx.h"

#include "icm.h"

#include <stdlib.h>
#include <stdarg.h>
#include <string.h>
#include <stdio.h>
#include <locale.h>
#include <math.h>

#include "os.h"
#include "wimp.h"
#include "wimpt.h"
#include "werr.h"
#include "akbd.h"
#include "bbc.h"
#include "flex.h"
#include "transform.h"
#include "xprocess.h"
#include "oscms.h"
#include "osgraphics.h"

#include "wos.h"

#include "err.h"
#include "xext.h"
#include "poll.h"
#include "osprint.h"
#include "key.h"
#include "temp.h"
#include "colour.h"
#include "xmath.h"
#include "drag.h"
#include "conf.h"
#include "redraw.h"
#include "etc.h"
#include "bits.h"
#include "wimptext.h"
#include "fsx.h"
#include "bf.h"
#include "flex.h"
#include "scanplus.h"
#include "deb.h"


#include "dbhi.h"
#include "mhi.h"




#include "str.h"
#include "constants.h"



#include "view.h"
#include "file.h"

#include "dbscale.h"

#include "xcolour.h"
#include "xxcolour.h"
#include "cconv.h"


#include "prstr.h"


#include "colsep.h"
#include "colseplink.h"





#include "colsepx.h"
#include "csstr.h"

#include "colcode.h"
#include "csnaive.h"
#include "csview.h"

#include "icc.h"


#include "lcms.h"


#define USEICM




#define CMS_NONE -1
#define CMS_NOINTENT 0


//#define CMS_BGRA 1
#define CMS_CMYK 2
//#define CMS_RGB  3
#define CMS_RGBA 4
//#define CMS_ARGB 5
//#define CMS_16   6


#define CMSADDALLOC 0x1







#ifndef USEICM


static os_error * cmserr;


static int cmsErrorHandler(int ErrorCode,const char *ErrorText)
{

 cmserr=generror(ErrorCode,(char*)ErrorText);
// errorbox((char*)ErrorText);

 return(1);

 USE(ErrorCode);
}


#endif


static os_error * XcmsCloseProfile(cmsHPROFILE hProfile)
{
	os_error * err;

#ifdef	USEICM
	{
  err=XCloseColorProfile((HPROFILE)hProfile);
		return(err);
 }
#else
	{
  cmserr=NULL;
  cmsCloseProfile(hProfile);
  return(cmserr);
	}
#endif
}





static os_error * XcmsOpenProfileFromFile(const char *ICCProfile, const char *sAccess,cmsHPROFILE * hprofile)
{
	os_error * err;

#ifdef USEICM
	{
		PROFILE Profile;

		Profile.cbDataSize=strlen(ICCProfile)+1;
		Profile.dwType=PROFILE_FILENAME;
		Profile.pProfileData=(void*)ICCProfile;

	 err=XOpenColorProfile(&Profile,PROFILE_READ,FILE_SHARE_READ,OPEN_EXISTING,(HPROFILE*)hprofile);

		return(err);
	}
#else
	{
  cmserr=NULL;
  *hprofile=cmsOpenProfileFromFile(ICCProfile,sAccess);
  return(cmserr);
	}
#endif
}



static os_error * XcmsOpenProfileFromMem(LPVOID MemPtr,DWORD dwSize,cmsHPROFILE * hprofile)
{
	os_error * err;

#ifdef USEICM
	{
		PROFILE Profile;

		Profile.cbDataSize=dwSize;
		Profile.dwType=PROFILE_MEMBUFFER;
		Profile.pProfileData=MemPtr;

	 err=XOpenColorProfile(&Profile,PROFILE_READ,FILE_SHARE_READ,OPEN_EXISTING,(HPROFILE*)hprofile);

		return(err);
	}
#else
	{
  cmserr=NULL;
  *hprofile=cmsOpenProfileFromMem(MemPtr,dwSize);
  return(cmserr);
	}
#endif
}



static void mapformat(int format,DWORD * cmsformat)
{
 if(format==CMS_CMYK)  *cmsformat=TYPE_CMYK_8;
 else
// if(format==CMS_RGB)   *cmsformat=TYPE_RGB_8;
// else
// if(format==CMS_BGRA)  *cmsformat=TYPE_BGRA_8;
// else
 if(format==CMS_RGBA)  *cmsformat=TYPE_RGBA_8;
// else
// if(format==CMS_ARGB)  *cmsformat=TYPE_ARGB_8;
 else                  *cmsformat=TYPE_BGRA_8;

}




static void icmmapformat(int format,BMFORMAT * icmformat)
{
 if(format==CMS_CMYK)  *icmformat=BM_KYMCQUADS;							// KKYYMMCC
 else
 if(format==CMS_RGBA)  *icmformat=BM_xBGRQUADS;	  				// XXBBGGRR
 else                  *icmformat=BM_RGBTRIPLETS;

}




//#define CMM_FROM_PROFILE 0

static os_error * XcmsCreateTransform(cmsHPROFILE Input,
                                       DWORD InputFormat,
                                       cmsHPROFILE Output,
                                       DWORD OutputFormat,
                                       int Intent,
                                       DWORD dwFlags,cmsHTRANSFORM * htransform)
{
	os_error * err;

#ifdef USEICM
	{
		HPROFILE Profiles[2];

		Profiles[0]=(HPROFILE)Input;
		Profiles[1]=(HPROFILE)Output;

  err=XCreateMultiProfileTransform(Profiles,2,(DWORD*)&Intent,1,NORMAL_MODE,CMM_FROM_PROFILE,(HTRANSFORM*)htransform);

		return(err);
	}
#else
	{
		DWORD inputformat;
		DWORD outputformat;

  mapformat(InputFormat,&inputformat);
  mapformat(OutputFormat,&outputformat);


  cmserr=NULL;
  *htransform=cmsCreateTransform(Input,inputformat,Output,outputformat,Intent,dwFlags);
  return(cmserr);
	}
#endif
}



static os_error * XcmsCreateProofingTransform(cmsHPROFILE Input,
                        DWORD InputFormat,
                        cmsHPROFILE Output,
                        DWORD OutputFormat,
                        cmsHPROFILE Proofing,
                        int Intent,
                        int ProofingIntent,
                        DWORD dwFlags,cmsHTRANSFORM * htransform)
{
	os_error * err;

#ifdef USEICM
	{
		HPROFILE Profiles[3];
		DWORD    Intents[3];

		Profiles[0]=(HPROFILE)Input;
		Profiles[1]=(HPROFILE)Proofing;
		Profiles[2]=(HPROFILE)Output;

		Intents[0]=INTENT_ABSOLUTE_COLORIMETRIC;
		Intents[1]=ProofingIntent;
		Intents[2]=Intent;

  err=XCreateMultiProfileTransform(Profiles,3,Intents,3,NORMAL_MODE,CMM_FROM_PROFILE,(HTRANSFORM*)htransform);

		return(err);
	}
#else
	{
		DWORD inputformat;
		DWORD outputformat;

  mapformat(InputFormat,&inputformat);
  mapformat(OutputFormat,&outputformat);

  cmserr=NULL;
  *htransform=cmsCreateProofingTransform(Input,inputformat,Output,outputformat,Proofing,Intent,ProofingIntent,dwFlags);
  return(cmserr);
	}
#endif
}


static os_error * XcmsDeleteTransform(cmsHTRANSFORM hTransform)
{
	os_error * err;

#ifdef USEICM
	{
		err=XDeleteColorTransform((HTRANSFORM)hTransform);

		return(err);
	}
#else
	{
  cmserr=NULL;
  cmsDeleteTransform(hTransform);
  return(cmserr);
	}
#endif
}




static os_error * XcmsIsTag(cmsHPROFILE hProfile,int tag,int * exists)
{
	os_error * err;

#ifdef USEICM
	{
		err=XIsColorProfileTagPresent((HPROFILE)hProfile,(TAGTYPE)tag,(PBOOL)exists);

		return(err);
	}
#else
	{
  cmserr=NULL;
 	*exists=cmsIsTag(hProfile,(icTagSignature)tag);
 	return(cmserr);
	}
#endif
}


static os_error * XcmsReadICCText(cmsHPROFILE hProfile,int tag,char * text,int size)
{
	os_error * err;

#ifdef USEICM
	{
		DWORD pcbSize;
		BOOL  ref;

		pcbSize=size;

//  err=XGetColorProfileElement((HPROFILE)hProfile,(TAGTYPE)tag,0,&pcbSize,NULL,&ref);
//  if(!err)
 err=XGetColorProfileElement((HPROFILE)hProfile,(TAGTYPE)tag,12,&pcbSize,text,&ref);

		return(NULL);
	}
#else
	{
  cmserr=NULL;
  cmsReadICCText(hProfile,(icTagSignature)tag,text);

//		cprintf("cmsread %s",text);
 	return(cmserr);
	}
#endif
}



static os_error * XcmsDoTransform(cmsHTRANSFORM hTransform,
                                  LPVOID InputBuffer,int informat,
                                  LPVOID OutputBuffer,int outformat,unsigned int Size)
{
	os_error * err;

#ifdef USEICM
	{
		BMFORMAT	bmInputFormat=BM_BGRTRIPLETS ;
		BMFORMAT bmOutputFormat=BM_BGRTRIPLETS ;


		icmmapformat(informat,&bmInputFormat);
		icmmapformat(outformat,&bmOutputFormat);

  err=XTranslateBitmapBits((HTRANSFORM)hTransform,InputBuffer,bmInputFormat,Size,1,0,
																																													OutputBuffer,bmOutputFormat,0,NULL,0);


		return(err);
	}
#else
	{
  cmserr=NULL;
  cmsDoTransform(hTransform,InputBuffer,OutputBuffer,Size);
  return(cmserr);
	}
#endif
}


static os_error * XcmsGetColorSpace(cmsHPROFILE hProfile,int * cspace)
{
	os_error * err;

#ifdef USEICM
	{
  PROFILEHEADER Header;
		err=XGetColorProfileHeader((HPROFILE)hProfile,&Header);
		*cspace=Header.phDataColorSpace;

		return(err);
	}
#else
	{
  cmserr=NULL;
  *cspace=cmsGetColorSpace(hProfile);
 	return(cmserr);
	}
#endif
}


#ifndef USEICM

static char * upaths[]=
{
 "<%SystemRoot%>\\System32\\SPOOL\\DRIVERS\\COLOR",
 "<%SystemRoot%>\\System32\\COLOR",
 "<%Windir%>\\System\\SPOOL\\DRIVERS\\COLOR",
 "<%Windir%>\\System\\COLOR"


};


#endif

static char * upath0;
static char * upath1;

static char   icmpath[MAX_PATH];


static os_error * XcmsGetPaths(void)
{
	os_error * err;

#ifdef USEICM
	{
		DWORD size;

		size=sizeof(icmpath);
  err=XGetColorDirectory(NULL,icmpath,&size);

		upath0=icmpath;
		upath1=NULL;

		return(err);
	}
#else
	{
 	if(ISW9X)
 	{
 		upath0=upaths[2];
 		upath1=upaths[3];
 	}
 	else
 	{
 		upath0=upaths[0];
 		upath1=upaths[1];
	 }

		return(NULL);
	}
#endif
}


static int icmpresent;


static os_error * XcmsInit(int icm)
{
	os_error * err;

	err=NULL;

//	useicm=0;

	if(icm)
	{
  err=icminit(&icmpresent);

  cprintf("cmsinit %d",icmpresent);
	}

	if(icmpresent)
	{
	 if(!err) err=XcmsGetPaths();
	}

#ifndef USEICM
	if(!useicm)
	{
  cmsErrorAction(LCMS_ERROR_SHOW);
  cmsSetErrorHandler(cmsErrorHandler);
	}
#endif

	return(err);
}



/***********************************************************************************/



static os_error * XcmsGetProductName(cmsHPROFILE hProfile,char * Name,int size)
{
	os_error * err;
 char       Manufacturer[512];
 char       Model[512];
	int        exists;


 Name[0]='\0';
 Manufacturer[0]=Model[0]='\0';


 err=XcmsIsTag(hProfile,icSigDeviceMfgDescTag,&exists);
	if(!err)
	{
//		cprintf("mfr ex %d",exists);
		if(exists)
  {
   err=XcmsReadICCText(hProfile,icSigDeviceMfgDescTag,Manufacturer,sizeof(Manufacturer));
  }

  if(!err) err=XcmsIsTag(hProfile,icSigDeviceModelDescTag,&exists);
		if(!err)
		{
//					cprintf("mod ex %d",exists);
			if(exists)
   {
    err=XcmsReadICCText(hProfile,icSigDeviceModelDescTag,Model,sizeof(Model));
   }

			if(!err)
			{
    if(!Manufacturer[0] && !Model[0])
    {
     err=XcmsIsTag(hProfile,icSigProfileDescriptionTag,&exists);
		 		if(!err)
		 		{
//								cprintf("desc ex %d",exists);
		 			if(exists)
      {
       err=XcmsReadICCText(hProfile,icSigProfileDescriptionTag,Name,size);
      }
      else
      {
       strcpy(Name,"{no name}");
      }
	    }
		 	}
		 	else
    if(!Manufacturer[0] || strncmp(Model,Manufacturer,8)==0 || strlen(Model)>30)
   	{
     err=xzstrncpye(Name,Model,size);
   	}
    else
    {
					err=xsprintf(size,NULL,Name, "%s - %s", Model, Manufacturer);
 	  }
			}
		}
	}

//	cprintf("*name %s",*name);
	
 return(err);
}



static os_error * XcmsGetProductDesc(cmsHPROFILE hProfile,char * Name,int size)
{
	os_error * err;
	int        exists;

	*Name=0;

 err=XcmsIsTag(hProfile,icSigProfileDescriptionTag,&exists);
	if(!err)
 {
		if(exists)
		{
   err=XcmsReadICCText(hProfile,icSigProfileDescriptionTag,Name,size);
   if(!err)
   {
    if(strncmp(Name,"Copyrig",7)==0)
				{
     err=XcmsGetProductName(hProfile,Name,size);
				}
			}
  }
  else
  {
   err=XcmsGetProductName(hProfile,Name,size);
		}
	}

 return(err);
}





/**************************************************************************************/







#define CMSTYPEFREE 0x0
#define CMSTYPEFILE 0x1
#define CMSTYPEMEM  0x2



typedef struct cmsprofilestr
{
 int             xtype;

 int             flags;
 char          * leaf;
 char          * name;
 cmsHPROFILE     profile;
 int             cspace;

 unsigned char * data;
 unsigned int    datalen;
 int             count;

} cmsprofilestr;


#define CMSCHUNK (16*sizeof(cmsprofilestr))



static cmsprofilestr * cmsprofile;
static int             cmsprofilen;
static int             cmsprofilen2;

/*

Location Purpose 
C:\WINDOWS\SYSTEM32\COLOR\ Photoshop 5 looks here. 
C:\WINDOWS\SYSTEM32\SPOOL\DRIVERS\COLOR\ Photoshop 6 and 7 look here. 

%system%

*/


//static char * upath="<HKEY_LOCAL_MACHINE\\Software\\DavidPilling\\DPScan\\>\\Profiles";







#define MAXPROFILENAME 128


//static char cmykname[MAXPROFILENAME];
//static int  cmykindex;

//static char monitorname[MAXPROFILENAME];
//static int  monitorindex;

//static char rgbname[MAXPROFILENAME];
//static int  rgbindex;

//static char scannername[MAXPROFILENAME];
//static int  scannerindex;

//static char printername[MAXPROFILENAME];
//static int  printerindex;


//static int  printerintent;
//static int  monitorintent;

//static int  cmsactive;
//static int  printcmsactive;
//static int  proofing;

//static int  xcmsactive;
//static int  xprintcmsactive;
//static int  xproofing;




static char * cmsintentname[]=
{
 "Perceptual",
 "Relative Colourimetric",
 "Saturation",
 "Absolute Colourimetric"
};


#define CMSINTENTN (sizeof(cmsintentname)/sizeof(char*))





static int cmykindexfromallindex(int index)
{
 int n;
 int i;

 n=-1;

 for(i=0;i<=index;i++)
 {
  if(cmsprofile[i].cspace==icSigCmykData) n++;
 }

 return(n);
}


static int allindexfromcmykindex(int index)
{
 int i;

	if(index>=0)
	{
  for(i=0;i<cmsprofilen;i++)
  {
   if(cmsprofile[i].cspace==icSigCmykData) index--;
   if(index<0) break;
  }

  if(index<0) return(i);
	}

 return(CMS_NONE);
}



static int rgbindexfromallindex(int index)
{
 int n;
 int i;

 n=-1;

 for(i=0;i<=index;i++)
 {
  if(cmsprofile[i].cspace==icSigRgbData) n++;
 }

 return(n);
}


static int allindexfromrgbindex(int index)
{
 int i;

	if(index>=0)
	{
  for(i=0;i<cmsprofilen;i++)
  {
   if(cmsprofile[i].cspace==icSigRgbData) index--;
   if(index<0) break;
  }

  if(index<0) return(i);
	}

	return(CMS_NONE);
}



static int cmsfindname(char * name)
{
 int i;

 for(i=0;i<cmsprofilen;i++)
 {
  if(!cstrcmp(name,cmsprofile[i].name)) break;
 }


 if(i>=cmsprofilen) return(CMS_NONE);

// cprintf("find name %s %s",name,cmsprofile[i].name);

 return(i);
}



static int cmsfindfilename(char * filename)
{
	os_error * err;
 int        i;
	char       path[MAX_PATH];
	char       name[MAX_PATH];

 for(i=0;i<cmsprofilen;i++)
 {
  err=fs_expandpath((cmsprofile[i].flags & 0x1)?upath1:upath0,path,sizeof(path));
  if(!err)
  {
   fs_join(name,NITEM(name),path,cmsprofile[i].leaf);

   if(!cstrcmp(filename,name)) break;
  }
	}

	cprintf("find %s found %d",filename,i<cmsprofilen);

 if(i>=cmsprofilen) return(CMS_NONE);

 cprintf("find name %s %s",name,cmsprofile[i].name);

 return(i);
}





static os_error * cmsmonitorsystem(int * index)
{
	os_error * err;
	char       buffer[MAX_PATH];
	DWORD      size=sizeof(buffer);

	err=NULL;

	buffer[0]=0;
	err=XGetDisplayProfile(buffer,&size);

	cprintf("bufffer %s size %d err %x",buffer,size,err);

 if(!err) *index=cmsfindfilename(buffer);

	return(err);
}




static os_error * cmsprintersystem(wimp_redrawstr * r,int * index)
{
	os_error * err;
	char       buffer[MAX_PATH];
	int        size=sizeof(buffer);

	err=NULL;


	buffer[0]=0;

	if(r)	err=XGetICMProfile(((hdcstr*)r->hdcptr)->hdc,(PDWORD)&size,buffer);
	else		err=osprintprofile(&size,buffer);

	cprintf("print profile %s",buffer);

 if(!err) *index=cmsfindfilename(buffer);

	return(err);
}








static int cmpxnames(const void * p1,const void * p2)
{
 cmsprofilestr * profile1;
 cmsprofilestr * profile2;

 profile1=(cmsprofilestr*)p1;
 profile2=(cmsprofilestr*)p2;

 return(cstrcmp(profile1->name,profile2->name));
}





static os_error * cmsgetprofiles(void)
{
 os_error * err;
 int        type0=0;
 int        type1=0;
 fxstat     f;
 int        eof;
// char    *  p;
 char    *  str;
 char       name[MAX_PATH];
 char       path0[MAX_PATH];
 char       path1[MAX_PATH];
 fsscanhandle handle;
 int        flags;
	int        cspace;
	char        buffer[1024];

 cmsprofilen=0;

	err=NULL;

	if(upath0)
	{
           err=fs_exists(upath0,&type0);
  if(!err) err=fs_expandpath(upath0,path0,sizeof(path0));
	}

 if(!err)
 {
		if(upath1)
		{
   err=fs_exists(upath1,&type1);
  if(!err) err=fs_expandpath(upath1,path1,sizeof(path1));
		}
	}

 if(!err && (type0>1 || type1>1))
 {
//  cprintf("double scan");

  err=fs_startdoublesortscan(upath0,upath1,"*.*",0,&handle);
  if(!err)
  {
//  cprintf("double scan1");

   while(1)
   {
//    cprintf("name %s",f.name);

    err=fs_nextdoublesortitem(handle,&f,&eof,&flags);
    if(err) break;
    if(eof) break;

    if(!fs_extensionis(f.name,"icm") || !fs_extensionis(f.name,"icc"))
    {
//    cprintf("profile %s",f.name);

     if(cmsprofile) err=flex_chunk((flex_ptr)&cmsprofile,(cmsprofilen+1)*sizeof(cmsprofilestr),CMSCHUNK);
     else           err=flex_alloc((flex_ptr)&cmsprofile,CMSCHUNK);

     if(!err)
     {
      err=stralloc(f.name,&str);
      if(!err)
      {
       cmsprofile[cmsprofilen].xtype=CMSTYPEFILE;

       cmsprofile[cmsprofilen].leaf=str;

       cmsprofile[cmsprofilen].flags=flags;

       cmsHPROFILE hInProfile;

       fs_join(name,NITEM(name),(flags & 1)?path1:path0,f.name);

       err=XcmsOpenProfileFromFile(name,"r",&hInProfile);
       if(!err && hInProfile!=NULL)
       {
								err=XcmsGetProductDesc(hInProfile,buffer,sizeof(buffer));

        err=stralloc(buffer,&str);
        if(!err)
        {
         cmsprofile[cmsprofilen].name=str;
         cmsprofile[cmsprofilen].profile=NULL;
								 XcmsGetColorSpace(hInProfile,&cspace);
         cmsprofile[cmsprofilen].cspace=cspace;


//         cprintf("name %s %x",str,cmsprofile[cmsprofilen].cspace);

        }
     
        XcmsCloseProfile(hInProfile);
       }
      }
      cmsprofilen++;
     }
    }
    if(err) break;
   }

   fs_enddoublesortscan(&handle);
  }

  if(!err)
  {
   qsort(cmsprofile,cmsprofilen,sizeof(cmsprofilestr),cmpxnames);
  }

  cmsprofilen2=cmsprofilen;
 }
 return(err);
}





/* int cscurvename(int n,string & s,int flags1,int flags2) */

int csprofilename(int fp)
{
 int      * stack;
 int        n;
 int        s;
 int        flags1;
 int        flags2;
 int        i;

	if(icmpresent)
	{
  stack=xstackptr();

  n=stack[fp];
  s=stack[fp+1];
  flags1=stack[fp+2];
  flags2=stack[fp+3];

  for(i=0;i<cmsprofilen;i++)
  {
   if(((cmsprofile[i].cspace==icSigRgbData) && (flags1 & 0x1)) ||
      ((cmsprofile[i].cspace==icSigCmykData) && (flags1 & 0x2))
     )
   {
    n--;
    if(n<0)
    {
     assignstring(s,cmsprofile[i].name);
     return(i+1);
    }
   }
  }
	}

 return(0);
}




static cmsHTRANSFORM hTransformCMYK2RGB;
static cmsHTRANSFORM hTransformRGB2CMYK;
static cmsHPROFILE   hProfileRGB;
static cmsHPROFILE   hProfileCMYK;


// RISC OS r|(g<<8)|(b<<16);  AABBGGRR
// Windows                    AARRGGBB


static int rgbprofileindex;
static int cmykprofileindex;
static int monitorprofileindex;
static int printerprofileindex;
static int sepsprofileindex;

static int monitorintent;
static int monitorflags;
static int printerintent;
static int printerflags;
static int sepsintent;




static int csprofilechange;


static os_error * csclearprofiles(void)
{
 os_error * err;

 err=NULL;

 if(hTransformCMYK2RGB) 
 {
  XcmsDeleteTransform(hTransformCMYK2RGB);
  hTransformCMYK2RGB=NULL;
 }

 if(hTransformRGB2CMYK) 
 {
  XcmsDeleteTransform(hTransformRGB2CMYK);
  hTransformRGB2CMYK=NULL;
 }

 if(hProfileRGB)
 {
  XcmsCloseProfile(hProfileRGB);
  hProfileRGB=NULL;
 }

 if(hProfileCMYK)
 {
  XcmsCloseProfile(hProfileCMYK);
  hProfileCMYK=NULL;
 }

 return(err);
}


os_error * cssetprofiles(int rgbindex,int cmykindex,int monitorindex,int printerindex)
{
 os_error * err;

 err=NULL;

	if(icmpresent)
	{
  rgbprofileindex=allindexfromrgbindex(rgbindex);

  cmykprofileindex=allindexfromcmykindex(cmykindex);

  monitorprofileindex=allindexfromrgbindex(monitorindex);

  printerprofileindex=allindexfromrgbindex(printerindex);


  err=csclearprofiles();

  csprofilechange=(rgbprofileindex!=CMS_NONE && cmykprofileindex!=CMS_NONE);

  cprintf("cmschange %d rgb %d cmyk %d",csprofilechange,rgbprofileindex,cmykprofileindex);
	}

 return(err); 
}


os_error * cssetprofiles2(int sepsindex)
{

	sepsprofileindex=allindexfromcmykindex(sepsindex);

	return(NULL);
}


os_error * cssetprofiles3(int xmonitorintent,int xmonitorflags,int xprinterintent,int xprinterflags,int xsepsintent)
{

 monitorintent=xmonitorintent;
 monitorflags=xmonitorflags;
 printerintent=xprinterintent;
 printerflags=xprinterflags;
 sepsintent=xsepsintent;

 return(NULL);
}


static os_error * cscheckprofiles(void)
{
 os_error *  err;
 char        path[MAX_PATH];
 char        name[MAX_PATH];


 err=NULL;

 if(csprofilechange)
 {
  err=fs_expandpath((cmsprofile[rgbprofileindex].flags & 0x1)?upath1:upath0,path,sizeof(path));
  if(!err)
  {
   fs_join(name,NITEM(name),path,cmsprofile[rgbprofileindex].leaf);
   err=XcmsOpenProfileFromFile(name,"r",&hProfileRGB);
  }

  if(!err)
  {
   err=fs_expandpath((cmsprofile[cmykprofileindex].flags & 0x1)?upath1:upath0,path,sizeof(path));
   if(!err)
   {
    fs_join(name,NITEM(name),path,cmsprofile[cmykprofileindex].leaf);
    err=XcmsOpenProfileFromFile(name,"r",&hProfileCMYK);
   }
  }

  if(!err)
  {
   err=XcmsCreateTransform(hProfileRGB,CMS_RGBA,
                           hProfileCMYK,CMS_CMYK,
                           0,0,&hTransformRGB2CMYK);

   if(!err) err=XcmsCreateTransform(hProfileCMYK,CMS_CMYK,
                           hProfileRGB,CMS_RGBA,
                           0,0,&hTransformCMYK2RGB);

  }

  csprofilechange=0;
 }

 return(err);
}





char * csprofilenameptr(int index,int flags)
{

	if(icmpresent)
	{
  if(flags & 0x1) index=allindexfromrgbindex(index);
  else
  if(flags & 0x2) index=allindexfromcmykindex(index);

  if(index>=0 && index<cmsprofilen) return(cmsprofile[index].name);
	}

 return("");
}



int csfindprofile(char * name,int flags)
{
 int index;

	if(icmpresent)
	{
  index=cmsfindname(name);

// cprintf("findprofile %d %s",index,name);
 
  if(index!=CMS_NONE)
  {
   if(flags & 0x1) index=rgbindexfromallindex(index);
   else
   if(flags & 0x2) index=cmykindexfromallindex(index);
  }
	}
	else
	{
		index=CMS_NONE;
	}

 return(index);
}


os_error * csiccinit(void)
{
 os_error * err;

 err=XcmsInit(1);

	if(icmpresent)
	{
	 if(!err) err=cmsgetprofiles();
	}

 return(err);
}


os_error * csiccfinit(void)
{
	os_error * err;

	err=NULL;

	if(icmpresent)
	{
  err=csclearprofiles();
	}

 return(err);
}


int csprofilesactive(void)
{
	return(icmpresent);
}


/********************************************************************************/


os_error * csprofileprgb2cmyk(quadstr * rgb,quadstr * cmyk)
{
 os_error * err;
 int        r;
 int        g;
 int        b;
 int        v;


	r=(rgb->type.rgb.r*255)/MAXCV;
 g=(rgb->type.rgb.g*255)/MAXCV;
 b=(rgb->type.rgb.b*255)/MAXCV;

 v=(b<<16)|(g<<8)|r;

 err=cscheckprofiles();
 if(!err)
 {
  if(hTransformRGB2CMYK)
  {
   err=XcmsDoTransform(hTransformRGB2CMYK,&v,CMS_RGBA,&v,CMS_CMYK,1);
  }
 }

 cmyk->type.cmyk.c=((v & 0xFF)*MAXCV)/255;
 cmyk->type.cmyk.m=(((v>>8) & 0xFF)*MAXCV)/255;
 cmyk->type.cmyk.y=(((v>>16) & 0xFF)*MAXCV)/255;
 cmyk->type.cmyk.k=(((v>>24) & 0xFF)*MAXCV)/255;

 return(err);
}


os_error * csprofilergb2cmyk(quadstr * rgb,quadstr * cmyk)
{
 os_error * err;
 int        r;
 int        g;
 int        b;
 int        v;

 r=(rgb->type.rgb.r*255)/MAXCV;
 g=(rgb->type.rgb.g*255)/MAXCV;
 b=(rgb->type.rgb.b*255)/MAXCV;

 v=(b<<16)|(g<<8)|r;

 err=cscheckprofiles();
 if(!err)
 {
  if(hTransformRGB2CMYK)
  {
   err=XcmsDoTransform(hTransformRGB2CMYK,&v,CMS_RGBA,&v,CMS_CMYK,1);
  }
 }

 cmyk->type.cmyk.c=((v & 0xFF)*MAXCV)/255;
 cmyk->type.cmyk.m=(((v>>8) & 0xFF)*MAXCV)/255;
 cmyk->type.cmyk.y=(((v>>16) & 0xFF)*MAXCV)/255;
 cmyk->type.cmyk.k=(((v>>24) & 0xFF)*MAXCV)/255;

 return(err);
}



os_error * csprofilepcmyk2rgb(quadstr * cmyk,quadstr * rgb)
{
 os_error * err;
 int        c;
 int        m;
 int        y;
 int        k;
 int        v;

 k=(cmyk->type.cmyk.k*255)/MAXCV;
 c=(cmyk->type.cmyk.c*255)/MAXCV;
 m=(cmyk->type.cmyk.m*255)/MAXCV;
 y=(cmyk->type.cmyk.y*255)/MAXCV;

 v=(k<<24)|(y<<16)|(m<<8)|c;

 err=cscheckprofiles();
 if(!err)
 {
  if(hTransformCMYK2RGB)
  {
   err=XcmsDoTransform(hTransformCMYK2RGB,&v,CMS_CMYK,&v,CMS_RGBA,1);
  }
 }

 rgb->type.rgb.r=((v & 0xFF)*MAXCV)/255;
 rgb->type.rgb.g=(((v>>8) & 0xFF)*MAXCV)/255;
 rgb->type.rgb.b=(((v>>16) & 0xFF)*MAXCV)/255;

 return(err);
}




os_error * csprofilecmyk2rgb(quadstr * cmyk,quadstr * rgb)
{
 os_error * err;
 int        c;
 int        m;
 int        y;
 int        k;
 int        v;

 k=(cmyk->type.cmyk.k*255)/MAXCV;
 c=(cmyk->type.cmyk.c*255)/MAXCV;
 m=(cmyk->type.cmyk.m*255)/MAXCV;
 y=(cmyk->type.cmyk.y*255)/MAXCV;

 v=(k<<24)|(y<<16)|(m<<8)|c;

 err=cscheckprofiles();
 if(!err)
 {
  if(hTransformCMYK2RGB)
  {
   err=XcmsDoTransform(hTransformCMYK2RGB,&v,CMS_CMYK,&v,CMS_RGBA,1);
  }
 }

 rgb->type.rgb.r=((v & 0xFF)*MAXCV)/255;
 rgb->type.rgb.g=(((v>>8) & 0xFF)*MAXCV)/255;
 rgb->type.rgb.b=(((v>>16) & 0xFF)*MAXCV)/255;

 return(err);
}





os_error * csprofilepcmyk2rgb3232(int * s,int * d,int size)
{
 os_error * err;

 err=cscheckprofiles();
 if(!err)
 {
  if(hTransformCMYK2RGB)
  {
   err=XcmsDoTransform(hTransformCMYK2RGB,s,CMS_CMYK,d,CMS_RGBA,size);
  }
 }

 return(err);
}





os_error * csprofilecmyk2rgb3232(int * s,int * d,int size)
{
 os_error * err;

 err=cscheckprofiles();
 if(!err)
 {
  if(hTransformCMYK2RGB)
  {
   err=XcmsDoTransform(hTransformCMYK2RGB,s,CMS_CMYK,d,CMS_RGBA,size);
  }
 }

 return(err);
}



os_error * csprofilepcmyk2bgr3232(int * s,int * d,int size)
{
 os_error * err;
 int      * s1;
 int      * d1;
 int        n;
 int        v;
 

 err=cscheckprofiles();
 if(!err)
 {
  if(hTransformCMYK2RGB)
  {
   err=XcmsDoTransform(hTransformCMYK2RGB,s,CMS_CMYK,d,CMS_RGBA,size);
  }
 }

 s1=d;
 d1=d;
 n=size;

 while(n--)
 {
  v=*s1++;
  *d1++=(v & 0xFF00)|((v>>16)&0xFF)|((v<<16)&0xFF0000);
 }

 return(err);
}




os_error * csprofilecmyk2bgr3232(int * s,int * d,int size)
{
 os_error * err;
 int      * s1;
 int      * d1;
 int        n;
 int        v;
 
 err=cscheckprofiles();
 if(!err)
 {
  if(hTransformCMYK2RGB)
  {
   err=XcmsDoTransform(hTransformCMYK2RGB,s,CMS_CMYK,d,CMS_RGBA,size);
  }
 }

 s1=d;
 d1=d;
 n=size;

 while(n--)
 {
  v=*s1++;
  *d1++=(v & 0xFF00)|((v>>16)&0xFF)|((v<<16)&0xFF0000);
 }

 return(err);
}




// rgb->cmyk followed by separation of cmyk back to rgb


os_error * csprofileprgb32torgb32(int * s,int * d,int size,int key,int mask)
{
 os_error * err;
 int tint;

 err=cscheckprofiles();
 if(!err)
 {
  if(hTransformRGB2CMYK)
  {
   err=XcmsDoTransform(hTransformRGB2CMYK,s,CMS_RGBA,d,CMS_CMYK,size);
  }
 }

 if(key==KEYCYAN)
 {
  if(mask==0)
  {
   while(size--)
   {
    tint=0xFF-((*d) & 0xFF);     /* cyan */
    *d++=(tint<<16)|(tint<<8)|tint;
   }
  }
  else
  {
   while(size--)
   {
    tint=0xFF-((*d) & 0xFF);     /* cyan */
    *d++=0xFFFF00|tint;
   }
  }
 }
 else
 if(key==KEYYELLOW)
 {
  if(mask==0)
  {
   while(size--)
   {
    tint=0xFF-(((*d)>>16) & 0xFF);  /* yellow */
    *d++=(tint<<16)|(tint<<8)|tint;
   }
  }
  else
  {
   while(size--)
   {
    tint=0xFF-(((*d)>>16) & 0xFF);  /* yellow */
    *d++=0xFFFF|(tint<<16);
   }
  }
 }
 else
 if(key==KEYMAGENTA)
 {
  if(mask==0)
  {
   while(size--)
   {
    tint=0xFF-(((*d)>>8) & 0xFF);  /* magenta */
    *d++=(tint<<16)|(tint<<8)|tint;
   }
  }
  else
  {
   while(size--)
   {
    tint=0xFF-(((*d)>>8) & 0xFF);  /* magenta */
    *d++=0xFF00FF|(tint<<8);
   }
  }
 }
 else
 if(key==KEYBLACK)
 {
  while(size--)
  {
   tint=0xFF-(((*d)>>24) & 0xFF);  /* black */
   *d++=(tint<<16)|(tint<<8)|tint;
  }
 }

 return(err);
}


os_error * csprofilergb32torgb32(int * s,int * d,int size,int key,int mask)
{
 os_error * err;

 err=csprofileprgb32torgb32(s,d,size,key,mask);

 return(err);
}







os_error * csprofilepbgr32tobgr32(int * s,int * d,int size,int key,int mask)
{
 os_error * err;
 int        tint;
 int      * s1;
 int      * d1;
 int        n;
 int        v;

 s1=s;
 d1=d;
 n=size;

 while(n--)
 {
  v=*s1++;
  *d1++=(v & 0xFF00)|((v>>16)&0xFF)|((v<<16)&0xFF0000);
 }


 err=cscheckprofiles();
 if(!err)
 {
  if(hTransformRGB2CMYK)
  {
   err=XcmsDoTransform(hTransformRGB2CMYK,d,CMS_RGBA,d,CMS_CMYK,size);
  }
 }

 if(key==KEYCYAN)
 {
  if(mask==0)
  {
   while(size--)
   {
    tint=0xFF-((*d) & 0xFF);     /* cyan */
    *d++=(tint<<16)|(tint<<8)|tint;
   }
  }
  else
  {
   while(size--)
   {
    tint=0xFF-((*d) & 0xFF);     /* cyan */
    *d++=0xFFFF|(tint<<16);
   }
  }
 }
 else
 if(key==KEYYELLOW)
 {
  if(mask==0)
  {
   while(size--)
   {
    tint=0xFF-(((*d)>>16) & 0xFF);  /* yellow */
    *d++=(tint<<16)|(tint<<8)|tint;
   }
  }
  else
  {
   while(size--)
   {
    tint=0xFF-(((*d)>>16) & 0xFF);  /* yellow */
    *d++=0xFFFF00|(tint);
   }
  }
 }
 else
 if(key==KEYMAGENTA)
 {
  if(mask==0)
  {
   while(size--)
   {
    tint=0xFF-(((*d)>>8) & 0xFF);  /* magenta */
    *d++=(tint<<16)|(tint<<8)|tint;
   }
  }
  else
  {
   while(size--)
   {
    tint=0xFF-(((*d)>>8) & 0xFF);  /* magenta */
    *d++=0xFF00FF|(tint<<8);
   }
  }
 }
 else
 if(key==KEYBLACK)
 {
  while(size--)
  {
   tint=0xFF-(((*d)>>24) & 0xFF);  /* black */
   *d++=(tint<<16)|(tint<<8)|tint;
  }
 }

 return(err);
}



os_error * csprofilebgr32tobgr32(int * s,int * d,int size,int key,int mask)
{
 os_error * err;

 err=csprofilepbgr32tobgr32(s,d,size,key,mask);

 return(err);
}


#define CSPCHUNK 0x200

static int * cspbuffer;

static os_error * csprofilebuffer(int size,int ** buff)
{
 os_error   * err;

 err=flex_chunk((flex_ptr)&cspbuffer,size,CSPCHUNK);
 *buff=cspbuffer;

 return(err);
}


os_error * csprofilepbgr24tobgr24(int * s,int * d,int size,int key,int mask)
{
 os_error * err;
 char     * p;
 int      * q;
 int      * buff;
 int        n;

 err=csprofilebuffer(size*sizeof(int),&buff);
 if(!err)
 {
  p=(char*)s;
  q=buff;
  n=size;

  while(n--)
  {
   *q++=p[2]|(p[1]<<8)|(p[0]<<16);  // XXBBGGRR
   p+=3;
  }

  err=csprofileprgb32torgb32(buff,buff,size,key,mask);   // NB calling correct version, printer or screen?

  p=(char*)d;
  q=buff;
  n=size;

  while(n--)
  {
   *p++=((*q)>>16) & 0xFF;
   *p++=((*q)>>8) & 0xFF;
   *p++=((*q)) & 0xFF;
   q++;
  }
 }
 
 return(err);
}


os_error * csprofilebgr24tobgr24(int * s,int * d,int size,int key,int mask)
{
 os_error * err;

 err=csprofilepbgr24tobgr24(s,d,size,key,mask);

 return(err);
}


os_error * csprofileprgb16torgb16(int * s,int * d,int size,int key,int mask)
{
 os_error * err;
 int      * p;
 int      * q;
 int      * buff;
 int        n;
 int        word;
 int        dest;

 err=csprofilebuffer(size*sizeof(int),&buff);
 if(!err)
 {
  p=s;
  q=buff;
  n=size;

  while((n-=2)>-2)
  {
   word=*p++;
   *q++=cstab16[(word & 0x1F)]|((cstab16[(word & 0x3E0)>>5])<<8)|((cstab16[(word & 0x7C00)>>10])<<16);  // XXBBGGRR

   *q++=cstab16[(word & 0x1F0000)>>16]|((cstab16[(word & 0x3E00000)>>21])<<8)|((cstab16[(word & 0x7C000000)>>26])<<16);  // XXBBGGRR
  }

  err=csprofileprgb32torgb32(buff,buff,size,key,mask);   // NB calling correct version, printer or screen?

  p=d;
  q=buff;
  n=size;

  while((n-=2)>-2)
  {
   word=*q++;

   dest=((word>>3)&0x1F)|((word>>6)&0x3E0)|((word>>9)&0x7C00);

   word=*q++;

   dest|=((word<<13)&0x1F0000)|((word<<10)&0x3E00000)|((word<<7)&0x7C000000);

   *p++=dest;
  }
 }


 return(err);
}


os_error * csprofilergb16torgb16(int * s,int * d,int size,int key,int mask)
{
 os_error * err;

 err=csprofileprgb16torgb16(s,d,size,key,mask);

 return(err);
}


os_error * csprofilepbgr16tobgr16(int * s,int * d,int size,int key,int mask)
{
 os_error * err;
 int      * p;
 int      * q;
 int      * buff;
 int        n;
 int        word;
 int        dest;

 err=csprofilebuffer(size*sizeof(int),&buff);
 if(!err)
 {
  p=s;
  q=buff;
  n=size;

  while((n-=2)>-2)
  {
   word=*p++;
   *q++=((cstab16[(word & 0x1F)])<<16)|((cstab16[(word & 0x3E0)>>5])<<8)|((cstab16[(word & 0x7C00)>>10]));  // XXBBGGRR

   *q++=((cstab16[(word & 0x1F0000)>>16])<<16)|((cstab16[(word & 0x3E00000)>>21])<<8)|((cstab16[(word & 0x7C000000)>>26]));  // XXBBGGRR
  }

  err=csprofileprgb32torgb32(buff,buff,size,key,mask);   // NB calling correct version, printer or screen?

  p=d;
  q=buff;
  n=size;

  while((n-=2)>-2)
  {
   word=*q++;

   dest=((word>>19)&0x1F)|((word>>6)&0x3E0)|((word<<7)&0x7C00);

   word=*q++;

   dest|=((word>>3)&0x1F0000)|((word<<10)&0x3E00000)|((word<<23)&0x7C000000);

   *p++=dest;
  }
 }

 return(err);
}


os_error * csprofilebgr16tobgr16(int * s,int * d,int size,int key,int mask)
{
 os_error * err;

 err=csprofilepbgr16tobgr16(s,d,size,key,mask);
 
 return(err);
}



os_error * csprofileprgb2cmyk3232(int * s,int * d,int size)
{
 os_error * err;

 err=cscheckprofiles();
 if(!err)
 {
  if(hTransformRGB2CMYK)
  {
   err=XcmsDoTransform(hTransformRGB2CMYK,s,CMS_RGBA,d,CMS_CMYK,size);
  }
 }

 return(err);
}



os_error * csprofilergb2cmyk3232(int * s,int * d,int size)
{
 os_error * err;

 err=cscheckprofiles();
 if(!err)
 {
  if(hTransformRGB2CMYK)
  {
   err=XcmsDoTransform(hTransformRGB2CMYK,s,CMS_RGBA,d,CMS_CMYK,size);
  }
 }

 return(err);
}



/*
os_error * csprofileprgb2cmykpal32(int * s,int * d,int size)
{
 os_error * err;

 err=NULL;

 USE(s);
 USE(d);
 USE(size);

 return(err);
}
*/

/*
os_error * csprofilergb2cmykpal32(int * s,int * d,int size)
{
 os_error * err;
 int      * d1;
 int        n;

 n=size;
 d1=d;

 while(n--)
 {
  *d1++=(*s++)>>8;
 }

 err=XcmsDoTransform(hTransformCMYK2RGB,d,d,size);

 return(err);
}
*/


/*
os_error * csprofilepcmyk2rgb32pal(int * s,int * d,int size)
{
 os_error * err;

 err=XcmsDoTransform(hTransformCMYK2RGB,s,d,size);

 while(size--)
 {
  *d++=(*s++)<<8;
 }

 return(err);
}

*/


/*
os_error * csprofilecmyk2rgb32pal(int * s,int * d,int size)
{
 os_error * err;

 err=XcmsDoTransform(hTransformCMYK2RGB,s,d,size);

 while(size--)
 {
  *d++=(*s++)<<8;
 }

 return(err);
}
*/

/*
os_error * csprofileprgb2cmyk1632(int * s,int * d,int size)
{
 os_error * err;

 err=NULL;

 USE(s);
 USE(d);
 USE(size);

 return(err);
}

*/

/*
os_error * csprofilergb2cmyk1632(int * s,int * d,int size)
{
 os_error * err;

 err=NULL;

 USE(s);
 USE(d);
 USE(size);

 return(err);
}
*/

/*
os_error * csprofilepcmyk2rgb3216(int * s,int * d,int size)
{
 os_error * err;

 err=NULL;

 USE(s);
 USE(d);
 USE(size);

 return(err);
}
*/

/*
os_error * csprofilecmyk2rgb3216(int * s,int * d,int size)
{
 os_error * err;

 err=NULL;

 USE(s);
 USE(d);
 USE(size);

 return(err);
}

*/
