/*->c.fill */
/* Fill code */



#include "stdafx.h"

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <math.h> 

#include "os.h"
#include "bbc.h"
#include "sprite.h"
#include "wimp.h"

#include "transform.h"

#include "xprocess.h"



#include "wos.h"
#include "poll.h"
#include "etc.h"
#include "fsx.h"
#include "bf.h"
#include "flex.h"
#include "sp.h"
#include "task.h"
#include "xhelp.h"
#include "trans.h"
#include "dbhi.h"
#include "key.h"
#include "temp.h"

#include "xext.h"



#include "constants.h"
#include "str.h"


#include "file.h"
#include "view.h"
#include "viewo.h"


#include "units.h"

#include "object.h"
#include "select.h"
#include "dscript.h"


#include "dbscale.h"

#include "xredraw.h"
#include "curve.h"





#include "filllink.h"
#include "fillstub.h"

#include "filltool.h"
#include "dbfill.h"
#include "fillobject.h"
#include "fillblob.h"
#include "fillhatch.h"
#include "fillgrad.h"


#include "fill.h"



HANDLE modulehandle;


char * fillpath;



#define XFNS 21         


static fndefn fntable[XFNS]=
{
 "openfillbox",(extfn)openfillbox,"",PVOID,0,
 "fillname",(extfn)fillname,"IR",PINT,2,

 "setfill",(extfn)setfill,"I",PVOID,1,
 "sethatchwidth",(extfn)sethatchwidth,"I",PVOID,1,
 "gethatchwidth",(extfn)gethatchwidth,"",PINT,0,
 "sethatchpattern",(extfn)sethatchpattern,"II",PVOID,2,
 "gethatchpattern",(extfn)gethatchpattern,"",PINT,0,
 "gethatchscale",(extfn)gethatchscale,"",PINT,0,

 "setblob",(extfn)setblob,"I",PVOID,1,
 "blobname",(extfn)blobname,"IR",PINT,2,
 "setblobwidth",(extfn)setblobwidth,"I",PVOID,1,
 "getblobwidth",(extfn)getblobwidth,"",PINT,0,
 "setblobpattern",(extfn)setblobpattern,"II",PVOID,2,
 "getblobpattern",(extfn)getblobpattern,"",PINT,0,
 "getblobscale",(extfn)getblobscale,"",PINT,0,
 "currentblob",(extfn)currentblob,"I",PINT,1,

 "setgraduated",(extfn)setgraduated,"I",PVOID,1,
 "graduatedname",(extfn)graduatedname,"IR",PINT,2,
 "currentgraduated",(extfn)currentgraduated,"I",PINT,1,

 "fillgetcolour",(extfn)fillgetcolour,"I",PINT,1,

 NULL,NULL,NULL,0,0
};


static xfnlink fnlink;


static os_error * scriptevent(int eventn,int userhandle,
                                                    void * data,int data1)
{
 remevent(EVENT_SCRIPTINIT,scriptevent,0);
 return(addsymboltable(fntable,&fnlink));

 USE(eventn);
 USE(userhandle);
 USE(data);
 USE(data1);
}








static os_error * dsfill(int fp,int argc,objectloc * loc)
{
 os_error          * err;
 int                 sp;
 dsobjectstr       * ds;
 dsobjectstr       * ds1;
 int               * dsstack;


 err=NULL;

 sp=fp+2; /* skip leading type/len */

 dsstack=dsstackptr();

 ds1=(dsobjectstr*)(dsstack+sp);

 ds=(dsobjectstr*)(dsstack+fp);
 ds->len=3*sizeof(int);
 ds->data.integer=ds1->data.integer;


 return(err);

 USE(loc);
 USE(argc);
}









static int dsnulllist[]={
                           DSTENDLIST
                          };



static dscreator dsdefs[]=
{
 0,0,0,0, "fill",      dsfill,    0,  DSTFILL,       dsnulllist,
 0,0,0,0, "blob",      dsblob,  0,  DSTBLOB,       dsnulllist,
 0,0,0,0, "hatch",     dshatch, 0,  DSTHATCH,      dsnulllist,
 0,0,0,0, "graduated", dsgrad,  0,  DSTGRADUATED,  dsnulllist,

};




static os_error * filldsinit(void)
{
 os_error * err;


 err=dsaddblock(dsdefs,sizeof(dsdefs)/sizeof(dscreator));

 return(err);
}





static templates temptable[]=
{
 TFILL,1,0,"Fill",
 TFILLBLOB,1,0,"Fl_blob",
 TFILLTOOL,1,0,"FillTool",
 TFILLHATCH,1,0,"Fl_hatch",
 TFILLGRAD,1,0,"Fl_grad",
 TLAST,0,0,""
};


static templink templatelink;




static os_error * templatesevent(int eventn,int userhandle,
                                                    void * data,int data1)
{
 remevent(EVENT_LOADTEMPLATES,templatesevent,0);

 return(addtemplates2(NULL,NULL,temptable,&templatelink,(ascaninstance)modulehandle));

 USE(eventn);
 USE(userhandle);
 USE(data);
 USE(data1);
}





static os_error * docevent1(int eventn,int userhandle,void * data,int data1)
{
 remevent(EVENT_DOCINIT1,docevent1,0);

 filldsinit();

 fillselectinit();

 blobrun();

 return(filltoolinit());

 USE(eventn);
 USE(userhandle);
 USE(data);
 USE(data1);
}





extern "C" __declspec(dllexport) os_error * entrypoint(char * path)
{ 
 os_error * err;

 fillpath=path;

          err=addevent(EVENT_LOADTEMPLATES,templatesevent,0); 
 if(!err) err=addevent(EVENT_SCRIPTINIT,scriptevent,0);
 if(!err) err=addevent(EVENT_DOCINIT1,docevent1,0);

 if(!err) err=fillobjectinit();
 if(!err) err=fillblobinit();
 if(!err) err=fillhatchinit();
 if(!err) err=fillgradinit();



 return(err);
}





extern "C" BOOL __stdcall _DllMainCRTStartup( 
    HINSTANCE hinstDLL,     // handle to DLL module 
    DWORD fdwReason,        // reason for calling function 
    LPVOID lpvReserved)     // reserved 
{
 
 modulehandle=(HMODULE)hinstDLL;
 return(TRUE);
}

