/*->c.filltool */
/* Fill tool code*/



#include "stdafx.h"

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <math.h> 

#include "os.h"
#include "bbc.h"
#include "sprite.h"
#include "wimp.h"

#include "transform.h"

#include "xprocess.h"



#include "wos.h"
#include "poll.h"
#include "etc.h"
#include "fsx.h"
#include "bf.h"
#include "flex.h"
#include "sp.h"
#include "task.h"
#include "xhelp.h"
#include "trans.h"
#include "dbhi.h"
#include "redraw.h"
#include "colour.h"
#include "xmath.h"
#include "key.h"


#include "constants.h"
#include "str.h"

#include "object.h"

#include "file.h"
#include "view.h"
#include "viewo.h"
#include "viewr.h"
#include "units.h"
#include "pref.h"
#include "select.h"
#include "posn.h"
#include "caret.h"
#include "xrline.h"
#include "xredraw.h"
#include "curve.h"
#include "undo.h"
#include "geometry.h"



#include "xcolour.h"
#include "dbcolour.h"


#include "toolstr.h"
#include "tools.h"
#include "mhi.h"



#include "fill.h"
#include "filllink.h"
#include "fillobject.h"
#include "dbfill.h"
#include "entry.h"

#include "filltool.h"






static int          cfillobject;
static filestr    * cfillfile;
static filltoolstr  cfilltool;
static fillstr      cfill;





static pointstr fillmoveptr=
{
 "p_fillmove",10,10
};



static pointstr fillrotateptr=
{
 "p_fillrotate",10,11
};




static iconmap cipmap[]=
{
 51,0,0,IP_TIPS,  /* X                0 */
  5,0,0,IP_TIPS,  /* Y                1 */
  6,0,0,IP_TIPS,  /* C1               2 */
  7,0,0,IP_TIPS,  /* C2               3 */
  8,0,0,IP_TIPS,  /* Rx               4 */
  9,0,0,IP_TIPS,  /* Ry               5 */
 10,0,0,IP_TIPS,  /* A                6 */
 11,0,0,IP_TIPS,  /* Sk               7 */

 14,0,0,IP_TIPS,  /* C1 =>            8 */
 15,0,0,IP_TIPS,  /* C2 =>            9 */
 16,0,0,IP_TIPS,  /* fill            10 */
 18,0,0,IP_TIPS,  /* fill =>         11 */
 23,0,0,IP_TIPS,  /* Delete          12 */

 0,0,0,0,   /* terminator */
};



#define CIPANGLE 6
#define CIPSKEW  7
#define CIPX     0
#define CIPY     1
#define CIPRX    4
#define CIPRY    5
#define CIPC1    2
#define CIPC2    3
#define CIPNAME  10



static filltoolstr deftool=
{
 0,              /* x */
 0,              /* y */
 MMUNITS(50),    /* rx       */
 MMUNITS(50),    /* ry       */
 0,              /* angle    */
 0,              /* skew     */
 OURBLACK,       /* c1       */
 OURWHITE,       /* c2       */
 FL_GRAD,        /* filltype */
 0x10000,        /* scale    */
 0x10000,        /* aspect   */
 0,              /* bits     */
 0,              /* process  */

};


/***************************************************************************/


/* convert between object and absolute parameters */

os_error * fill2global(filestr * file,int object,filltoolstr * tool)
{
 sobjectstr * sob;
 boxbitstr    bits;
 coordstr     cx;
 transformstr tr;


 sob=(sobjectstr*)fob_find(object,file);

 getboxbits(&sob->fcurve.box,&sob->transform,&bits);

 tool->angle+=bits.angle;

 cx.x=tool->x;
 cx.y=tool->y;
 tr_setidentity(&tr);
 tr_setrotationa(&tr,bits.angle);
 tr_transformset(&cx,1,&tr);

 tool->x=cx.x+bits.orgx;
 tool->y=cx.y+bits.orgy;

 return(NULL);
}





os_error * fill2local(filestr * file,int object,filltoolstr * tool)
{
 sobjectstr * sob;
 boxbitstr    bits;
 coordstr     cx;
 transformstr tr;


 sob=(sobjectstr*)fob_find(object,file);

 getboxbits(&sob->fcurve.box,&sob->transform,&bits);

 tool->angle-=bits.angle;

 cx.x=tool->x-bits.orgx;
 cx.y=tool->y-bits.orgy;

 tr_setidentity(&tr);
 tr_setrotationa(&tr,-bits.angle);
 tr_transformset(&cx,1,&tr);

 tool->x=cx.x;
 tool->y=cx.y;

 return(NULL);
}











static filltoolstr   * xfilltool;


static os_error * fillobjectfn(objhdrstr * obj,filestr * file,int * message)
{
 os_error      * err;
 fillstr         newfill;
 fillstr         oldfill;
 int             message2;
 fillblockstr  * xfillp;
 filltoolstr     lfill;
 int             key;
 undofillstr     undofill;
 int             master;
 objectbitstr    bits;


 err=NULL;

 key=obj->key;

 xfillp=findfillblock(xfilltool->filltype);
 if(xfillp)
 {
  err=objectmaster(key,file,&master,&bits);
  if(!err)
  {
   if(!master || bits.local)
   {
    message2=OM_GETFILL;
    objectmessage2(key,file,&message2,&oldfill);

    if(!message2)
    {
     if(xfillp->apply)
     {
      lfill=*xfilltool;
      fill2local(file,key,&lfill);
      err=xfillp->apply(file,&lfill,&newfill,&cfill);

      if(!err)
      {
       message2=OM_SETFILL;
       objectmessage2(key,file,&message2,&newfill);

       undofill.object=key;
       undofill.newfill=newfill;
       undofill.oldfill=oldfill;

       undowritefn(file,USFILL,&undofill,sizeof(undofill));
      }
     }
    }
   }
  }
 }

 return(err);

 USE(message);
}




static os_error * fillselection(filestr * file,filltoolstr * tool)
{
 os_error          * err;
 int                 selectn;
 selectedobjectstr * selection;
 filestr           * selfile;
 int                 selpage;
 int                 selsect;
 int                 message;


 err=NULL;


 xfilltool=tool;

 selfile=getselection(&selpage,&selsect,&selection,&selectn);
 if(selfile==file)
 {
  err=modfile(selfile,selsect);
  if(!err)
  {
   err=undostart(selfile);
   if(!err)
   {
    unfillselectionf(selfile);

    message=OM_FUNCTION;

    selectionmessage(file,&message,(void*)fillobjectfn);

    unfillselections(selfile);

    undoend(selfile);
   }
  }
 }

 return(err);
}





static fillstr xfill;
static int     xfillobject;
static int     xxfillobject;



static os_error * getfillobjectfn(objhdrstr * obj,filestr * file,int * message)
{
 os_error * err;
 int        message2;

 err=NULL;

 if(obj->key!=xxfillobject)
 {
  message2=OM_GETFILL;
  xfillobject=obj->key;
  err=objectmessage(obj,file,&message2,&xfill);
  if(!message2)
  {
   if(xfill.fill) *message=0;
  }
 }

 return(err);
}



static os_error * getfillselection(filestr * file,fillstr * fill,
                                   int * object,int xobject)
{
 os_error * err;
 int        message;

 err=NULL;

 xxfillobject=xobject;
 fill->fill=0;
 *object=0;

 message=OM_FUNCTION;
 selectionmessage(file,&message,(void*)getfillobjectfn);

 if(!message)
 {
  *fill=xfill;
  if(fill->fill) *object=xfillobject;
  else           *object=0;
 }

 return(err);
}



static os_error * getcfill(filestr * file,fillstr * cfill,
                                          filltoolstr * cfilltool)
{
 fillobjectstr * fob;
 fillblockstr  * fillp;

 fob=(fillobjectstr*)fob_find(cfill->fill,file);

 fillp=findfillblock(fob->filltype);

 if(fillp)
 {
  if(fillp->tool) fillp->tool(file,cfilltool,cfill);
 }

 return(NULL);
}


/*
static os_error * getcobjectfill(filestr * file,int cobject,
                                                filltoolstr * cfill)
{
 os_error * err;
 int        message;
 fillstr    fill;

 message=OM_GETFILL;
 err=objectmessage2(cobject,file,&message,&fill);

 getcfill(file,&fill,cfill);
 fill2global(file,cobject,cfill);

 return(err);
}
*/

/****************************************************************************/



#define FLSHIFT      1
#define FLSCALE      2
#define FLSKEW       3
#define FLSCALEONLY  4
#define FLSCALEANGLE 5
#define FLSKEWONLY   6
#define FLSKEWANGLE  7



static filltoolstr dfill;
static filltoolstr ofill;


static posnstr     cstartposn;
static int         cdragmode;
static int         cupdate;
static int         cskip;
static int         cstartdistance;
static int         cdragfillobject;






static os_error * cipupdate(filestr * file,filltoolstr * nfill)
{
 os_error * err;

 err=fillselection(file,nfill);

 return(err);
}





static os_error * cipkey(int handle,int userhandle,int icon,int * key)
{
 os_error   * err;
 viewstr    * view;
 filestr    * file;
 toolboxstr * toolbox;
 filltoolstr  nfill;
 char       * p;

 err=NULL;

 if(*key==13)
 {
  view=(viewstr *)userhandle;
  file=view->file;
  toolbox=file->toolbox;

  nfill=cfilltool;

  iconaddr(handle,cipmap[CIPX].realicon,&p);
  stringtounits(p,&nfill.x,view->data.units);
  nfill.x+=prefp(file)->rulerx;

  iconaddr(handle,cipmap[CIPY].realicon,&p);
  stringtounits(p,&nfill.y,view->data.units);
  nfill.y+=prefp(file)->rulery;

  iconaddr(handle,cipmap[CIPRX].realicon,&p);
  stringtounits(p,&nfill.rx,view->data.units);

  iconaddr(handle,cipmap[CIPRY].realicon,&p);
  stringtounits(p,&nfill.ry,view->data.units);

  iconaddr(handle,cipmap[CIPANGLE].realicon,&p);
  readangle(&nfill.angle,p);

  iconaddr(handle,cipmap[CIPSKEW].realicon,&p);
  readangle(&nfill.skew,p);

  *key=-1;

  cipupdate(file,&nfill);
 }

 return(err);
 USE(icon);
}







static filestr * colfile;


/* check could be stiffer */

static void c1close(colourvalue * colour)
{
 filltoolstr nfill;

 if(toolcurrent(colfile)==TL_FILL)
 {
  nfill=cfilltool;
  nfill.c1=*colour;
  cipupdate(colfile,&nfill);
 }
}


static void c2close(colourvalue * colour)
{
 filltoolstr nfill;

 if(toolcurrent(colfile)==TL_FILL)
 {
  nfill=cfilltool;
  nfill.c2=*colour;
  cipupdate(colfile,&nfill);
 }
}






static os_error * cipclick(int handle,int userhandle,wimp_mousestr * m)
{
 os_error   * err;
 viewstr    * view;
 filestr    * file;
 toolboxstr * toolbox;


 err=NULL;

 view=(viewstr *)userhandle;
 file=view->file;
 toolbox=file->toolbox;


 switch(m->i)
 {
  case  14:
           colfile=file;
           err=pickcolour(file,&cfilltool.c1,c1close,NULL);
           break;

  case  15:
           colfile=file;
           err=pickcolour(file,&cfilltool.c2,c2close,NULL);
           break;

  case  18:
           err=filldbox(view,file);
           break;

  case  23:
           err=remfillselection(file);
           break;
 }

 return(err);

 USE(handle);
}




static os_error * cipwrite(filltoolstr * cfilltool,viewstr * view,int handle)
{
 filestr      * file;
 char           string[32];
 fillblockstr * rootp;


 file=view->file;


 if(cfillobject)
 {
  writeangle(cfilltool->angle,string);
  writeiconc(handle,cipmap[CIPANGLE].realicon,string);
  writeskew(cfilltool->skew,string);
  writeiconc(handle,cipmap[CIPSKEW].realicon,string);

  writeiconc(handle,cipmap[CIPX].realicon,
                     unitstostring(cfilltool->x-prefp(file)->rulerx,
                     view->data.units));

  writeiconc(handle,cipmap[CIPY].realicon,
                     unitstostring(cfilltool->y-prefp(file)->rulery,
                     view->data.units));

  writeiconc(handle,cipmap[CIPRX].realicon,
unitstostring(scale(cfilltool->rx,cfilltool->scale,0x10000),view->data.units));

  writeiconc(handle,cipmap[CIPRY].realicon,
 unitstostring(scale(cfilltool->ry,ttmul(cfilltool->scale,cfilltool->aspect),0x10000),
                     view->data.units));

  rootp=findfillblock(cfilltool->filltype);
  if(rootp)
  {
   tsprintf(32,string,rootp->name);
   writeiconc(handle,cipmap[CIPNAME].realicon,string);
  }
 }
 else
 {
  writeiconc(handle,cipmap[CIPANGLE].realicon,"");
  writeiconc(handle,cipmap[CIPSKEW].realicon,"");
  writeiconc(handle,cipmap[CIPX].realicon,"");
  writeiconc(handle,cipmap[CIPY].realicon,"");
  writeiconc(handle,cipmap[CIPRX].realicon,"");
  writeiconc(handle,cipmap[CIPRY].realicon,"");
  writeiconc(handle,cipmap[CIPNAME].realicon,"");
 }

 return(NULL);
}



static os_error * ciprefresh(viewstr * view,int handle,int code)
{
 filestr          * file;
 toolboxstr       * toolbox;


 file=view->file;
 toolbox=file->toolbox;


 if(code==-1) 
 {
  writeiconf(view->info,IP_HELPI,"%s","{FIL00}");
 }


 if(code & 0x1)
 {
  if(cdragmode) cipwrite(&dfill,view,handle);
  else          cipwrite(&cfilltool,view,handle);
 }

 if(code & 0x2)
 {
  wimp_set_icon_state(handle,cipmap[CIPC1].realicon,
                              (wimp_iconflags)0,(wimp_iconflags)0);
  wimp_set_icon_state(handle,cipmap[CIPC2].realicon,
                              (wimp_iconflags)0,(wimp_iconflags)0);
 }

 return(NULL);
}





static os_error * cipredraw(viewstr * view,int handle,wimp_redrawstr * redraw)
{
 os_error * err;
 filestr  * file;

 file=view->file;

 if(cfillobject)
 {
           err=redrawblock(redraw,handle,cipmap[CIPC1].realicon,
                                       vfindcolour2(NULL,file,&cfilltool.c1));
  if(!err) err=redrawblock(redraw,handle,cipmap[CIPC2].realicon,
                                       vfindcolour2(NULL,file,&cfilltool.c2));
 }
 else
 {
           err=redrawblock(redraw,handle,cipmap[CIPC1].realicon,-1);
  if(!err) err=redrawblock(redraw,handle,cipmap[CIPC2].realicon,-1);
 }

 return(err);
}






/****************************************************************************/


#define LINKTHICK 4000

#define ECWIDTH  2
#define ECHEIGHT 5


#define CFHSIZE   80000
#define CFVSIZE   50000



static void gengadget(xlinestr * line1,xlinestr * line2,
                                     filltoolstr * cfilltool,int xpo,int ypo)
{
 transformstr tr;
 int          yscale;


 line1->thickness=LINKTHICK;
 line1->endcaps=2;
 line1->style=0;
 line1->ecw=ECWIDTH;
 line1->ech=ECHEIGHT;


 line1->ex=cfilltool->x+xpo;
 line1->ey=cfilltool->y+ypo;

 tr_setidentity(&tr);
 tr_setrotationa(&tr,cfilltool->angle);

 line1->ox=scale(CFHSIZE,cfilltool->scale,0x10000);
 line1->oy=0;

 tr_delta(&tr,&line1->ox,&line1->oy);
 line1->ox+=line1->ex;
 line1->oy+=line1->ey;

 setxlineboxoffends(line1);

 *line2=*line1;


 line2->ex=cfilltool->x+xpo;
 line2->ey=cfilltool->y+ypo;

 tr_setrotationa(&tr,cfilltool->angle-cfilltool->skew);

 yscale=ttmul(cfilltool->scale,cfilltool->aspect);
 line2->oy=-scale(CFVSIZE,yscale,0x10000);
 line2->ox=0;

 tr_delta(&tr,&line2->ox,&line2->oy);
 line2->ox+=line2->ex;
 line2->oy+=line2->ey;

 setxlineboxoffends(line2);
}










static os_error * cmenu(toolboxstr * toolbox,viewstr * view,
                                             filestr * file,wimp_mousestr * m)
{
 return(openmenu("main_menu"));
 USE(view);
 USE(file);
 USE(m);
 USE(toolbox);
}





static os_error * ckey(toolboxstr * toolbox,int * key,fkeyfn * fk)
{
 os_error * err;
 int        ch;
 viewstr  * view;

 err=menukey(key);
 if(!err)
 {
  if(*key==-1) *fk=menukey;
  else
  {
   ch=*key;
   if(ch==DEL)
   {
    view=getmenuview();
    err=remfillselection(view->file);
   }
  }
 }

 return(err);

 USE(toolbox);
}




static os_error * cchange(int eventn,int user,filestr * file,int object)
{
 if(toolcurrent(file)==TL_FILL)
 {

  iprefreshpane(file,0x1,IP_PANE1);


 }

 return(NULL);
 USE(eventn);
 USE(user);
 USE(object);
}





static os_error * cdselection(int eventn,int user,filestr * file,int object)
{
 int        page;

 if(toolcurrent(file)==TL_FILL)
 {
  if(object==cfillobject)
  {
   getselection(&page,NULL,NULL,NULL);
   viewrefresharea(file,page,NULL,VRTOOLS|VRONELAYER);

   getfillselection(file,&cfill,&cfillobject,object);
   if(cfillobject)
   {
    cfillfile=file;
    getcfill(file,&cfill,&cfilltool);
    fill2global(file,cfillobject,&cfilltool);

    getselection(&page,NULL,NULL,NULL);
    viewrefresharea(file,page,NULL,VRTOOLS|VRONELAYER);
    iprefreshpane(file,0x3,IP_PANE1);
   }
   else
   {
    cfillfile=NULL;
    iprefreshpane(file,0x3,IP_PANE1);
   }
  }
 }

 return(NULL);
 USE(eventn);
 USE(user);
 USE(object);
}





static os_error * csselection(int eventn,int user,filestr * file,int object)
{
 int     page;

 if(toolcurrent(file)==TL_FILL)
 {
  if(!cfillobject)
  {
   getfillselection(file,&cfill,&cfillobject,0);
   if(cfillobject)
   {
    cfillfile=file;
    getcfill(file,&cfill,&cfilltool);
    fill2global(file,cfillobject,&cfilltool);

    getselection(&page,NULL,NULL,NULL);
    viewrefresharea(file,page,NULL,VRTOOLS|VRONELAYER);

    iprefreshpane(file,0x3,IP_PANE1);
   }
   else
   {
    cfillfile=NULL;
    iprefreshpane(file,0x3,IP_PANE1);
   }
  }
 }

 return(NULL);
 USE(eventn);
 USE(user);
 USE(object);
}



static os_error * fillchange0(int eventn,int user,filestr * file,int spare)
{
 os_error * err;
 int        page;

 err=NULL;

 if(toolcurrent(file)==TL_FILL)
 {
  if(cfillobject)
  {
   getselection(&page,NULL,NULL,NULL);
   viewrefresharea(file,page,NULL,VRTOOLS|VRONELAYER);
   cskip=1;
  }
 }

 return(err);

 USE(spare);
 USE(user);
 USE(eventn);
}



static os_error * fillchange1(int eventn,int user,filestr * file,int spare)
{
 os_error * err;
 int        page;


 err=NULL;

 if(toolcurrent(file)==TL_FILL)
 {
  cskip=0;
  getfillselection(file,&cfill,&cfillobject,0);
  if(cfillobject)
  {
   cfillfile=file;
   getcfill(file,&cfill,&cfilltool);
   fill2global(file,cfillobject,&cfilltool);

   getselection(&page,NULL,NULL,NULL);
   viewrefresharea(file,page,NULL,VRTOOLS|VRONELAYER);
  }
  else
  {
   cfillfile=NULL;
  }

  iprefreshpane(file,0x3,IP_PANE1);
 }

 return(err);

 USE(spare);
 USE(user);
 USE(eventn);
}




static os_error * fillclose(int eventn,int user,filestr * file,int data1)
{
 if(file==cfillfile) 
 {
  cfillfile=NULL;
  cfillobject=0;
 }

 return(NULL);
 USE(eventn);
 USE(user);
 USE(data1);
}








static int findarrow(posnstr * posn)
{
 viewstr   * view;
 xlinestr    line1;
 xlinestr    line2; 
 int         v1;
 int         v2;
 int         arrow;

 arrow=0;

 gengadget(&line1,&line2,&cfilltool,0,0);
 view=posn->view;

 v1=insidexline(posn->x,posn->y,&line1,view);
 v2=insidexline(posn->x,posn->y,&line2,view);

 if(v1==XLBODY || v2==XLBODY) arrow=FLSHIFT;
 else
 if(v1==XLEC0) arrow=FLSCALE;
 else
 if(v2==XLEC0) arrow=FLSKEW;

 return(arrow);
}




static os_error * cclick(toolboxstr * toolbox,posnstr * posn)
{
 os_error     * err;
 int            object;
 filestr      * file;
 int            page;
 int            section;
 int            n;
 int            arrow;


 err=NULL;


 if(!posn->ghost)
 {
  arrow=0;
  file=getselection(&page,&section,NULL,&n);
  if(n && file==posn->file && page==posn->page)
  {
   if(cfillobject)
   {
    arrow=findarrow(posn);
   }
  }

  if(posn->buttons==VBDRAGS || posn->buttons==VBLONGCLICKS ||
     posn->buttons==VBDRAGA || posn->buttons==VBLONGCLICKA)
  {
   cdragfillobject=cfillobject;
   if(cfillobject)
   {
    dfill=cfilltool;

    if(arrow==FLSCALE)
    {
     if(posn->buttons==VBDRAGS ||posn->buttons==VBLONGCLICKS)arrow=FLSCALEONLY;
     else                                                   arrow=FLSCALEANGLE;
    }
    else
    if(arrow==FLSKEW)
    {
     if(posn->buttons==VBDRAGS ||posn->buttons==VBLONGCLICKS)arrow=FLSKEWONLY;
     else                                                   arrow=FLSKEWANGLE;
    }
   }
   else
   {
    if(findbox(posn,-1) && isselectedbig(posn->object,posn->file))
    {
     cfillobject=posn->object;
     dfill=deftool;
     dfill.x=posn->x;
     dfill.y=posn->y;
     cfilltool=dfill;
     arrow=FLSHIFT;
     viewrefresharea(file,page,NULL,VRTOOLS|VRONELAYER);
     iprefreshpane(file,0x3,IP_PANE1);
    }
   }

   if(arrow)
   {
    if(arrow==FLSHIFT) toolschangepointer2(128,USERPOINTER,&fillmoveptr,(char*)modulehandle);
    else               toolschangepointer2(128,USERPOINTER,&fillrotateptr,(char*)modulehandle);

    cdragmode=arrow;
    cstartposn=*posn;
    toolsstartdrag(posn,TOOLDRAGPAGE|TOOLDRAGKN|TOOLDRAGPTR);
    cstartdistance=pythag(cstartposn.x-cfilltool.x,cstartposn.y-cfilltool.y);
   }
  }
  else
  if(arrow)
  {


  }
  else
  if(findboxhandle(posn))
  {


  }
  else
  {
   if(findbox(posn,-1))
   {
    if(posn->buttons==VBCLICKS                 || 
//       posn->buttons==VBCLICKCS                ||
       posn->buttons==VBCLICKCA ||
       posn->buttons==VBCLICKSS)
    {
     if(!isselectedbig(posn->object,posn->file))
     {
      changeselection(posn,SELECTOBJECT,1);
     }
    }
    else
    if(posn->buttons==VBCLICKA || posn->buttons==VBCLICKCS) /* single click adjust */
    {
     if((object=isselectedbig(posn->object,posn->file))!=0)
     {
      posn->object=object;
      changeselection(posn,DESELECTOBJECT,0);
     }
     else
     {
      changeselection(posn,SELECTOBJECT,0);
     }
    }
    else
    if(posn->buttons==VBLONGCLICKS ||
       posn->buttons==(VBLONGCLICKS|VBSHIFT) ||
       posn->buttons==(VBLONGCLICKS|VBCTRL) ||
       posn->buttons==VBDRAGCS || 
       posn->buttons==VBDRAGSS)
    {


    }
   }
   else  /*  not on a box or anything */
   {
    if(posn->buttons==VBCLICKS  || 
       posn->buttons==VBCLICKCS || posn->buttons==VBCLICKSS)
    {
     clearselection();
    }
   }
  }



  if(!cdragmode)
  {
   if(arrow)
   {
    if(arrow==FLSHIFT) toolschangepointer2(8,USERPOINTER,&fillmoveptr,(char*)modulehandle);
    else               toolschangepointer2(8,USERPOINTER,&fillrotateptr,(char*)modulehandle);
   }
   else
   {
    toolschangepointer(0,SYSTEMPOINTER,NULL);
   }
  }
 }

 caretensure(posn->view);

 return(err);

 USE(toolbox);
}






static os_error * cmove(toolboxstr * toolbox,posnstr * posn,int move)
{
 filestr * file;
 int       page;
 aboxstr   abox;
 int       doredraw;
 int       arrow;
 int       n;


 if(move)
 {
  if(!posn->ghost)
  {
   file=getselection(&page,NULL,NULL,&n);

   if(file==posn->file && page==posn->page && n)
   {
    if(cdragmode==0)
    {
     if(cfillobject && (arrow=findarrow(posn))!=0)
     {
      if(arrow==FLSHIFT) toolschangepointer(8,USERPOINTER,&fillmoveptr);
      else               toolschangepointer(8,USERPOINTER,&fillrotateptr);
     }
     else
     {
      toolschangepointer(0,SYSTEMPOINTER,NULL);
     }
    }
    else
    {
     doredraw=0;
     ofill=dfill;

     if(cdragmode==FLSHIFT)
     {
      dfill.x=cfilltool.x+(posn->x-cstartposn.x);
      dfill.y=cfilltool.y+(posn->y-cstartposn.y);
      doredraw=1;
     }
     else
     if(cdragmode==FLSCALE)
     {
      dfill.angle=scaleatan2(posn->y-cfilltool.y,posn->x-cfilltool.x);
      dfill.scale=scale(0x10000,pythag(posn->y-cfilltool.y,
                                       posn->x-cfilltool.x),cstartdistance);

      doredraw=1;
     }
     else
     if(cdragmode==FLSCALEONLY)
     {
      dfill.scale=scale(0x10000,pythag(posn->y-cfilltool.y,
                                       posn->x-cfilltool.x),cstartdistance);
      doredraw=1;
     }
     else
     if(cdragmode==FLSCALEANGLE)
     {
      dfill.angle=scaleatan2(posn->y-cfilltool.y,posn->x-cfilltool.x);
      doredraw=1;
     }
     else
     if(cdragmode==FLSKEW)
     {
      dfill.skew=-(scaleatan2(posn->y-cfilltool.y,posn->x-cfilltool.x)+
                                                    90*0x10000-dfill.angle);

      dfill.aspect=scale(0x10000,pythag(posn->y-cfilltool.y,
                                        posn->x-cfilltool.x),cstartdistance);
      doredraw=1;
     }
     else
     if(cdragmode==FLSKEWONLY)
     {
      dfill.aspect=scale(0x10000,pythag(posn->y-cfilltool.y,
                                        posn->x-cfilltool.x),cstartdistance);
      doredraw=1;
     }
     else
     if(cdragmode==FLSKEWANGLE)
     {
      dfill.skew=-(scaleatan2(posn->y-cfilltool.y,posn->x-cfilltool.x)+
                                                    90*0x10000-dfill.angle);
      doredraw=1;
     }


     if(doredraw)
     {
      cupdate=1;

      abox.x0=cstartposn.xps-cstartposn.xpo;
      abox.x1=cstartposn.xpe-cstartposn.xpo;
      abox.y1=cstartposn.ype-cstartposn.ypo;
      abox.y0=cstartposn.yps-cstartposn.ypo;

      viewrefresharea(posn->file,posn->page,&abox,VRTOOLS|VRONELAYER);

      cupdate=0;
    
      iprefreshpane(posn->file,0x1,IP_PANE1);
     }
    }
   }
  }
  else
  {
   toolschangepointer(0,SYSTEMPOINTER,NULL);
  }
 }

 return(NULL);

 USE(toolbox);
 USE(posn);
 USE(move);
}





static os_error * cdragend(toolboxstr * toolbox,
                               posnstr * posn,wimp_box * box)
{
 filestr * file;
 aboxstr   abox;


 if(cdragmode)
 {
  file=posn->file;

  abox.x0=cstartposn.xps-cstartposn.xpo;
  abox.x1=cstartposn.xpe-cstartposn.xpo;
  abox.y1=cstartposn.ype-cstartposn.ypo;
  abox.y0=cstartposn.yps-cstartposn.ypo;

  viewrefresharea(file,posn->page,&abox,VRTOOLS|VRONELAYER);

  cdragmode=0;
  cfillobject=0;    /* so tool does not redraw */

/*  cskip=1; */

  fillselection(file,&dfill);

/*  cskip=0;


  getfillselection(file,&fill,&cfillobject,0);
  if(cfillobject)
  {
   cfillfile=file;
   getcfill(file,&fill,&cfilltool);
   fill2global(file,cfillobject,&cfilltool);
   viewrefresharea(file,posn->page,&abox,VRTOOLS|VRONELAYER);
  }
  else
  {
   cfillfile=NULL;
  }

  iprefreshpane(file,0x3,IP_PANE1); */
 }


 return(NULL);

 USE(box);
 USE(posn);
 USE(toolbox);
}



static os_error * ccancel(toolboxstr * toolbox,viewstr * view,
                                                   filestr * file)
{
 aboxstr abox;
 int     page;

 if(cdragmode)
 {

  cupdate=1;

  if(!cdragfillobject) cupdate|=2;

  abox.x0=cstartposn.xps-cstartposn.xpo;
  abox.x1=cstartposn.xpe-cstartposn.xpo;
  abox.y1=cstartposn.ype-cstartposn.ypo;
  abox.y0=cstartposn.yps-cstartposn.ypo;

  ofill=dfill;
  dfill=cfilltool;

  getselection(&page,NULL,NULL,NULL);

  viewrefresharea(file,page,&abox,VRTOOLS|VRONELAYER);

  cupdate=0;

  cdragmode=0;
  cfillobject=cdragfillobject;
  toolsstopdrag();
  iprefreshpane(file,0x1,IP_PANE1);
 }

 return(NULL);

 USE(toolbox);
 USE(view);
 USE(file);
}





static ipstr cipstr=
{
 cipclick,       /* click    */
 cipkey,         /* key      */
 cipmap,         /* icon map */
 TFILLTOOL,      /* template */
 cipredraw,      /* redraw   */
 ciprefresh,     /* refresh  */
};




static os_error * cselect(toolboxstr * toolbox,viewstr * view,
                                                   filestr * file,int select)
{
 int     page;

 ipchangepane(toolbox,IP_PANE1,select?&cipstr:NULL);

 if(select)
 {
  getfillselection(file,&cfill,&cfillobject,0);
  if(cfillobject)
  {
   cfillfile=file;
   getcfill(file,&cfill,&cfilltool);
   fill2global(file,cfillobject,&cfilltool);

   getselection(&page,NULL,NULL,NULL);
   viewrefresharea(file,page,NULL,VRTOOLS|VRONELAYER);
  }
  else
  {
   cfillfile=NULL;
  }
 }
 else
 {
  if(cfillobject)
  {
   getselection(&page,NULL,NULL,NULL);
   viewrefresharea(file,page,NULL,VRTOOLS|VRONELAYER);
  }
  cfillfile=NULL;
 }


 return(NULL);

 USE(toolbox);
 USE(view);
 USE(file);
}




static os_error * xcptr(toolboxstr * toolbox,posnstr * posn)
{
 int arrow;

 if(cfillobject && (arrow=findarrow(posn))!=0)
 {
  if(arrow==FLSHIFT) toolschangepointer2(8,USERPOINTER,&fillmoveptr,(char*)modulehandle);
  else               toolschangepointer2(8,USERPOINTER,&fillrotateptr,(char*)modulehandle);
 }

 return(NULL);


 USE(toolbox);
 USE(posn);
}







static os_error * credrawfill(filltoolstr * cfilltool,viewredrawstr * v)
{
 xlinestr     line1;
 xlinestr     line2;

 seteorcol(WIMPWHITE,WIMPBLACK);

 gengadget(&line1,&line2,cfilltool,v->xpo,v->ypo);
 setxlinevars(&line1,3,v);
 setxlinevars(&line2,3,v);

 return(NULL);
}





static os_error * credraw(toolboxstr * toolbox,viewredrawstr * v)
{
 filestr * file;
 int       page;
 int       section;
 int       n;


 file=getselection(&page,&section,NULL,&n);
 if(n && file==v->file && page==v->page && !cskip)
 {
  if(cdragmode)
  {
   if(cupdate & 0x1)    credrawfill(&ofill,v);
   if(!(cupdate & 0x2)) credrawfill(&dfill,v);
  }
  else
  {
   if(cfillobject)
   {
    credrawfill(&cfilltool,v);
   }
  }
 }

 USE(toolbox);

 return(NULL);
}





static toolstr fill=
{
 TL_FILL,
 "fill",
 "t_fill\0t_pfill",
 "{FILTIP}",
 1,
 cclick,
 cmove,
 cselect,
 xcptr,
 ccancel,
 credraw,
 cdragend,
 cmenu,
 ckey,
 NULL,
 NULL,
 NULL,

 0,

 0,       /*  preselect */
 0,       /*  noicon    */
 0,       /*  spare2    */
 0,       /*  spare3    */
 0,       /*  spare4    */ 
 0,       /*  spare5    */
 0,       /*  spare6    */
 0,       /*  spare7    */


 TPOINTER,
 0,
 0,
 100,     /*  rank      */
};





os_error * filltoolinit(void)
{
 addevent(EVENT_OBJECTSELECTED1,(eventfn)csselection,0);
 addevent(EVENT_OBJECTDESELECTED0,(eventfn)cdselection,0);
 addevent(EVENT_TRANSFORMSELECTION,(eventfn)cchange,0);
 addevent(EVENT_FILLCHANGE0,(eventfn)fillchange0,0);
 addevent(EVENT_FILLCHANGE1,(eventfn)fillchange1,0);
 addevent(EVENT_FCLOSE,(eventfn)fillclose,0);

 cfilltool.x=72000*3;
 cfilltool.y=72000*3;
 cfilltool.scale=0x10000;
 cfilltool.aspect=0x10000; 
 cfilltool.rx=20000;
 cfilltool.ry=20000;

 return(toolregister(&fill));
}



