/*->c.tw */


#include "stdafx.h"

#include <stdlib.h>
#include <stdarg.h>
#include <string.h>
#include <stdio.h>
#include <locale.h>
#include <tchar.h>
#include <wia.h>
#include <sti.h>
#include <comdef.h>



#include "os.h"
#include "wimp.h"
#include "wimpt.h"
#include "werr.h"
#include "wos.h"
#include "flex.h"
#include "transform.h"
#include "xprocess.h"


#include "err.h"
#include "fsx.h"
#include "task.h"
#include "poll.h"
#include "alloc.h"
#include "trans.h"
#include "etc.h"
#include "bf.h"
#include "colour.h"
#include "deb.h"
#include "dbhi.h"
#include "bitrev.h"
#include "ram.h"
#include "scrap.h"
#include "oscom.h"
#include "filetype.h"

#include "constants.h"
#include "str.h"

#include "object.h"
#include "chain.h"
#include "view.h"
#include "viewr.h"
#include "file.h"
#include "select.h"

#include "txstr.h"
#include "mx.h"
#include "pxstr.h"
#include "pxbmp.h"
#include "pict.h"
#include "draw.h"
#include "impex.h"




#include "tw.h"



/****************************************************************************/




static HRESULT CreateWiaDeviceManager(IWiaDevMgr ** ppWiaDevMgr)
{
 if(NULL==ppWiaDevMgr)
 {
  return(E_INVALIDARG);
 }

 *ppWiaDevMgr = NULL;

 HRESULT hr=CoCreateInstance(CLSID_WiaDevMgr,NULL,CLSCTX_LOCAL_SERVER,IID_IWiaDevMgr,(void**)ppWiaDevMgr);

 return(hr);
}


/*****************************************************************************/

static char devicename[256];



/* open select source dialogue */

os_error * wiaselect(void)
{
 os_error * err;
 viewstr  * view;

 err=NULL;

 view=getmenuview();
 if(view)
 {
		HRESULT hr;

  IWiaDevMgr *pWiaDevMgr=NULL;

  hr=CreateWiaDeviceManager(&pWiaDevMgr);
  if(SUCCEEDED(hr))
  {
			BSTR bstr1;

		 enablewindow(view->handle,0,1);

			hr=pWiaDevMgr->SelectDeviceDlgID((HWND)view->handle,StiDeviceTypeDefault,0,&bstr1);

			if(hr==WIA_S_NO_DEVICE_AVAILABLE)
			{
    err=generror(0,TEXT("No WIA devices available."));
			}
			else
			if(hr==S_FALSE)	// Cancelled
			{
				err=geterror(ESAVECANCELLED);
			}
			else
   if(FAILED(hr))
   {
    err=generror(0,TEXT("Error calling EnumerateWiaDevices"));
   }
			else
			{
				_bstr_t bstr(bstr1,0);

 			strcpy(devicename,(char*)bstr);
			}

   enablewindow(view->handle,1,1); 

   pWiaDevMgr->Release();
   pWiaDevMgr=NULL;
		}
 }

 return(err);
}

/****************************************************************************/
/* code for acquiring images */

	
int acqpict;



#define DIBSHIFT 14


static os_error * twload(int object,int type,filestr * file,viewstr * view)
{
 os_error   * err;
 posnstr      posn;
 pictboxstr * pictp;
 int          page;
 int          section;


// bmpinitpicture(object,type,file);

 pictp=(pictboxstr*)fob_find(acqpict,file);
 pagesectionof((chainobject*)pictp,file,&page,&section);

 err=modfile(file,section);
 if(!err)
 {
 	memset(&posn,0,sizeof(posnstr));
 	posn.branch=view->branch;
 	posn.section=section;
 	posn.page=page;
 	posn.file=file;
 	posn.view=view;
 	posn.object=acqpict;

  err=pictloadsub(type,object,&posn);
 }

 return(err);
}







os_error * wiaacquire(void)
{
 os_error   * err;
 pictboxstr * pictp;
 int          page;
 int          section;
	int          sh;
	int          filetype=BMP;
	int          object;
 filestr    * acqfile;
 viewstr    * acqview;


 err=NULL;

 acqview=getmenuview();
 acqfile=acqview->file;


 if(nselected(&acqpict,acqfile))
 {
  pictp=(pictboxstr*)fob_find(acqpict,acqfile);
  if(pictp->type!=OPICTBOX)
  {
   pagesectionof((chainobject*)pictp,acqfile,&page,&section);
   err=txconvertable(acqpict,section,acqfile);
  }

		if(!err)
		{
   err=sc_create(&sh);
  	if(!err)
  	{
  		HRESULT hr;

    IWiaDevMgr *pWiaDevMgr=NULL;
    IWiaItem * pWiaItemRoot=NULL;

    hr=CreateWiaDeviceManager(&pWiaDevMgr);
    if(SUCCEEDED(hr))
    {
		   GUID guid=IID_NULL; //WiaImgFmt_BMP;

  			_bstr_t bstr(sc_namex(sh));

  		 enablewindow(acqview->handle,0,1);

	 			if(strlen(devicename))
	 			{
   			_bstr_t bdevid(devicename);
  				hr=pWiaDevMgr->CreateDevice(bdevid,&pWiaItemRoot);
						if(hr!=S_OK) pWiaItemRoot=NULL;
	 			}

     hr=pWiaDevMgr->GetImageDlg((HWND)acqview->handle,StiDeviceTypeDefault,
                                 WIA_SELECT_DEVICE_NODEFAULT|WIA_DEVICE_DIALOG_SINGLE_IMAGE,WIA_INTENT_NONE,
 	  																													pWiaItemRoot,
 	  																													bstr,&guid);

  			if(hr==WIA_S_NO_DEVICE_AVAILABLE)
  			{
      err=generror(0,TEXT("No WIA devices available."));
  			}
 	 		else
 		 	if(hr==E_NOTIMPL)
 		 	{
      err=generror(0,TEXT("No user interface available."));
 		 	}
  			else
  			if(hr==S_FALSE)	// Cancelled
  			{
  				err=geterror(ESAVECANCELLED);
  			}
  			else
     if(FAILED(hr))
     {
      err=generror(0,TEXT("Error calling Get Image Dialogue"));
     }
  			else
  			{
  				if(guid==WiaImgFmt_BMP) filetype=BMP;
   			else
   			if(guid==WiaImgFmt_JPEG)	filetype=JPEG;
   			else
   			if(guid==WiaImgFmt_PNG) filetype=PNG;
   			else
   			if(guid==WiaImgFmt_GIF)	filetype=GIF;
   			else
   			if(guid==WiaImgFmt_TIFF) filetype=TIFFTYPE;
   			else
 	 			{
					  err=fs_identify(&filetype,sc_namex(sh));
 	 			}
 	 		}

     enablewindow(acqview->handle,1,1); 

     pWiaDevMgr->Release();
     pWiaDevMgr=NULL;
    }
    else
    {
     err=generror(0,TEXT("Error calling CreateWiaDeviceManager"));
    }


    if(!err)
    {
     err=importload(sc_namex(sh),filetype,1,&object,acqfile);
     err=importloadpost(filetype,object,acqfile);

//              err=dxloadchunk(sc_namex(sh),0,&object,acqfile);
     if(!err) err=twload(object,filetype,acqfile,acqview);
  			fs_delete(sc_namex(sh));
  		}
  		else
  		{
  			if(err->errnum==ESAVECANCELLED) err=NULL;
  		}

    err=sc_remove(sh,err);
	 	}
		}
 }

 return(err);
}





/*****************************************************************************/

static os_error * wiaterminate(int eventn,int userhandle,
                                                        void * data,int data1)
{

	oscomfinit();

 return(NULL);

 USE(eventn);
 USE(userhandle);
 USE(data);
 USE(data1);
}


os_error * wiainit(void)
{
	os_error * err;

 addevent(EVENT_ENDPROGRAM,wiaterminate,0);

	err=oscominit();

 return(err);
}

